/* ============================================================================
 * Copyright (C) 2004 - Infineon Technologies AG.
 *
 * All rights reserved.
 * ============================================================================
 *
 * ============================================================================
 *
 * This document contains proprietary information belonging to Infineon
 * Technologies AG. Passing on and copying of this document, and communication
 * of its contents is not permitted without prior written authorisation.
 *
 * ============================================================================
 */

/* ===========================================================================
 *
 * File Name    : adslAturChanIntervalTable_access.c
 * Author       : Subbi
 * Date         : 17-Jun-2004
 *
 * ===========================================================================
 *
 * Project      : Amazon
 * Block        : ADSL-MIBs
 *
 * ===========================================================================
 * Contents: This file contains functions for:
 *                 1) Getting the data context pointer & loop context pointer
 *                 2) User-defined data access functions (per column) for data
 *                    in table adslAturChanIntervalTable
 *
 *
 * ===========================================================================
 * References: RFC 2662
 *
 */

/* ===========================================================================
 * Revision History:
 * Subramani:  29-Jun04 Changed the return type for intervalValidData
 *
 * $Log$
 * ===========================================================================
 */

/*
 * Note: this file originally auto-generated by mib2c using
 *        : mib2c.access_functions.conf,v 1.6 2003/09/11 22:48:49 rstory Exp $
 */

/*
 * ===========================================================================
 *                           INCLUDE FILES
 * ===========================================================================
 */
#include <net-snmp/net-snmp-config.h>
#include <net-snmp/net-snmp-includes.h>
#include <net-snmp/agent/net-snmp-agent-includes.h>
#include "adslAturChanIntervalTable_access.h"
#include "adslAturChanIntervalTable_enums.h"

/* column number definitions for table adslAturChanIntervalTable */
#include "adslAturChanIntervalTable_columns.h"

/*
 * ===========================================================================
 *                           GLOBAL DEFINITIONS
 * ===========================================================================
 */
// *** Global variable definitions
static long long_ret;

/*
 * ===========================================================================
 *                           LOCAL FUNCTIONS
 * ===========================================================================
 */
/* returns the first data point within the adslAturChanIntervalTable table data.

    Set the my_loop_context variable to the first data point structure
    of your choice (from which you can find the next one).  This could
    be anything from the first node in a linked list, to an integer
    pointer containing the beginning of an array variable.

    Set the my_data_context variable to something to be returned to
    you later that will provide you with the data to return in a given
    row.  This could be the same pointer as what my_loop_context is
    set to, or something different.

    The put_index_data variable contains a list of snmp variable
    bindings, one for each index in your table.  Set the values of
    each appropriately according to the data matching the first row
    and return the put_index_data variable at the end of the function.
*/
netsnmp_variable_list *
adslAturChanIntervalTable_get_first_data_point(void **my_loop_context,
                                               void **my_data_context,
                                               netsnmp_variable_list *
                                               put_index_data,
                                               netsnmp_iterator_info
                                               *mydata)
{

   int *My_Data_Context;
   My_Data_Context = SNMP_MALLOC_TYPEDEF(int);
   if (!My_Data_Context) {
      put_index_data = NULL;
      snmp_log(LOG_ERR, "Get-First: adslAturChanIntervalTable: My_Data_Context malloc failed\n");
      return put_index_data;
   }
   *My_Data_Context=IFTYPE_ADSL_FAST_INTERLEAVE;
   *my_data_context=My_Data_Context;

   put_index_data = adslTable_get_first_data_point(my_loop_context,
                                   my_data_context,
                                   put_index_data,
                                   mydata);

    SNMP_FREE(My_Data_Context);
    return put_index_data;
}

/** functionally the same as adslAturChanIntervalTable_get_first_data_point, but
   my_loop_context has already been set to a previous value and should
   be updated to the next in the list.  For example, if it was a
   linked list, you might want to cast it to your local data type and
   then return my_loop_context->next.  The my_data_context pointer
   should be set to something you need later and the indexes in
   put_index_data updated again. */
netsnmp_variable_list *
adslAturChanIntervalTable_get_next_data_point(void **my_loop_context,
                                              void **my_data_context,
                                              netsnmp_variable_list *
                                              put_index_data,
                                              netsnmp_iterator_info
                                              *mydata)
{

    int *My_Data_Context;
    My_Data_Context = SNMP_MALLOC_TYPEDEF(int);
    if (!My_Data_Context) {
      put_index_data = NULL;
      snmp_log(LOG_ERR, "Get-Next: adslAturChanIntervalTable: My_Data_Context malloc failed\n");
      return put_index_data;
    }
    *My_Data_Context=IFTYPE_ADSL_FAST_INTERLEAVE;
    *my_data_context=My_Data_Context;

    put_index_data = adslTable_get_next_data_point(my_loop_context,
                                   my_data_context,
                                   put_index_data,
                                   mydata);

    SNMP_FREE(My_Data_Context);
    return put_index_data;
}


/*
 *  User-defined data access functions (per column) for data in table
    adslAturChanIntervalTable */
/*
 * NOTE:
 * - these get_ routines MUST return data that will not be freed (ie,
 *   use static variables or persistent data).  It will be copied, if
 *   needed, immediately after the get_ routine has been called.
 * - these SET routines must copy the incoming data and can not take
 *   ownership of the memory passed in by the val pointer.
 */
#if defined(HAVE_OPTIMIZED_CODE)

u_int32  *
get_adslAturChanIntervalData(void *data_context, size_t * ret_len, 
		unsigned int var)
{
  unsigned int flags = 0;
  struct adslAturChanIntvlInfo adslAturChanIntvlStruct;
  memset(&adslAturChanIntvlStruct,0,sizeof(adslAturChanIntvlInfo));
  adslAturChanIntvlStruct.ifIndex= (*(int *)data_context);
  adslAturChanIntvlStruct.IntervalNumber= (*(int *)ret_len);
   
  switch (var) {

    case COLUMN_ADSLATURCHANINTERVALRECEIVEDBLKS:
  	flags = ATUR_CHAN_INTVL_RECV_BLK_FLAG;
        break;
	
    case COLUMN_ADSLATURCHANINTERVALTRANSMITTEDBLKS:
	flags = ATUR_CHAN_INTVL_TX_BLK_FLAG;
	break;
	
    case COLUMN_ADSLATURCHANINTERVALCORRECTEDBLKS:
	flags = ATUR_CHAN_INTVL_CORR_BLK_FLAG;
	break;
	
    case COLUMN_ADSLATURCHANINTERVALUNCORRECTBLKS:
	flags = ATUR_CHAN_INTVL_UNCORR_BLK_FLAG;
	break;

    default:
     	DEBUGMSGTL(("Unknown MIB variable requested!", "\n"));
        return NULL;
  }

  SET_FLAG(&adslAturChanIntvlStruct.flags, flags);

#ifdef ENABLE_DRIVER_CALL
  adsl_ioctl(Fd, GET_ADSL_ATUR_CHAN_INTVL_INFO, &adslAturChanIntvlStruct);
#else
  get_adslAturChanIntervalTable(Fd, GET_ADSL_ATUR_CHAN_INTVL_INFO,
        (void *) &adslAturChanIntvlStruct);
#endif
  if (IS_FLAG_SET(&adslAturChanIntvlStruct.flags,flags) == 0) 
    DEBUGMSGTL(("adslMIB-ATUR", "ChanIntervalTable: GET- %x CMV fail\n", flags));

    switch (flags)  {

	 case ATUR_CHAN_INTVL_RECV_BLK_FLAG:
    	    long_ret = adslAturChanIntvlStruct.chanIntervalRecvdBlks;
            break;
	 
	 case ATUR_CHAN_INTVL_TX_BLK_FLAG:
    	    long_ret = adslAturChanIntvlStruct.chanIntervalXmitBlks;
	    break;
	  
	 case ATUR_CHAN_INTVL_CORR_BLK_FLAG:
    	    long_ret = adslAturChanIntvlStruct.chanIntervalCorrectedBlks;
	    break;
	  
	 case ATUR_CHAN_INTVL_UNCORR_BLK_FLAG:
    	    long_ret = adslAturChanIntvlStruct.chanIntervalUncorrectBlks;
	    break;
	  
         default:
     	    DEBUGMSGTL(("Unknown MIB variable requested!", "\n"));
            return NULL;
     }

    CLR_FLAG(&adslAturChanIntvlStruct.flags, flags);
    *ret_len = sizeof(u_int32);
    return (u_int32 *) &long_ret;
}

#else

/** XXX: return a data pointer to the data for the
    adslAturChanIntervalReceivedBlks column and set ret_len to its
    proper size in bytes. */
u_int32  *
get_adslAturChanIntervalReceivedBlks(void *data_context, size_t * ret_len)
{
    struct adslAturChanIntvlInfo adslAturChanIntvlStruct;

    memset(&adslAturChanIntvlStruct,0,sizeof(adslAturChanIntvlInfo));
    adslAturChanIntvlStruct.ifIndex= (*(int *)data_context);
    adslAturChanIntvlStruct.IntervalNumber= (*(int *)ret_len);
    SET_FLAG(&adslAturChanIntvlStruct.flags, ATUR_CHAN_INTVL_RECV_BLK_FLAG);

#ifdef ENABLE_DRIVER_CALL
    adsl_ioctl(Fd, GET_ADSL_ATUR_CHAN_INTVL_INFO, &adslAturChanIntvlStruct);
#else
    get_adslAturChanIntervalTable(Fd, GET_ADSL_ATUR_CHAN_INTVL_INFO,
        (void *) &adslAturChanIntvlStruct);
#endif
    if (IS_FLAG_SET(&adslAturChanIntvlStruct.flags,
        ATUR_CHAN_INTVL_RECV_BLK_FLAG) == 0) 
       DEBUGMSGTL(("adslMIB-ATUR", "ChanIntvlRecvBlk CMV fail\n"));

    CLR_FLAG(&adslAturChanIntvlStruct.flags, ATUR_CHAN_INTVL_RECV_BLK_FLAG);
    long_ret = adslAturChanIntvlStruct.chanIntervalRecvdBlks;
    *ret_len = sizeof(adslAturChanIntvlStruct.chanIntervalRecvdBlks);
    return (u_int32 *) &long_ret;
}

/** XXX: return a data pointer to the data for the
    adslAturChanIntervalTransmittedBlks column and set ret_len to its
    proper size in bytes. */
u_int32  *
get_adslAturChanIntervalTransmittedBlks(void *data_context,
                                         size_t * ret_len)
{
    struct adslAturChanIntvlInfo adslAturChanIntvlStruct;

    memset(&adslAturChanIntvlStruct,0,sizeof(adslAturChanIntvlInfo));
    adslAturChanIntvlStruct.ifIndex= (*(int *)data_context);
    adslAturChanIntvlStruct.IntervalNumber= (*(int *)ret_len);
    SET_FLAG(&adslAturChanIntvlStruct.flags, ATUR_CHAN_INTVL_TX_BLK_FLAG);

#ifdef ENABLE_DRIVER_CALL
    adsl_ioctl(Fd, GET_ADSL_ATUR_CHAN_INTVL_INFO, &adslAturChanIntvlStruct);
#else
    get_adslAturChanIntervalTable(Fd, GET_ADSL_ATUR_CHAN_INTVL_INFO,
        (void *) &adslAturChanIntvlStruct);
#endif
    if (IS_FLAG_SET(&adslAturChanIntvlStruct.flags,
            ATUR_CHAN_INTVL_TX_BLK_FLAG) == 0) 
       DEBUGMSGTL(("adslMIB-ATUR", "ChanIntvlTxBlk CMV fail\n"));

    CLR_FLAG(&adslAturChanIntvlStruct.flags, ATUR_CHAN_INTVL_TX_BLK_FLAG);
    long_ret = adslAturChanIntvlStruct.chanIntervalXmitBlks;
    *ret_len = sizeof(adslAturChanIntvlStruct.chanIntervalXmitBlks);
    return (u_int32 *) &long_ret;
}

/** XXX: return a data pointer to the data for the
    adslAturChanIntervalCorrectedBlks column and set ret_len to its
    proper size in bytes. */
u_int32  *
get_adslAturChanIntervalCorrectedBlks(void *data_context,
                                       size_t * ret_len)
{
    struct adslAturChanIntvlInfo adslAturChanIntvlStruct;

    memset(&adslAturChanIntvlStruct,0,sizeof(adslAturChanIntvlInfo));
    adslAturChanIntvlStruct.ifIndex= (*(int *)data_context);
    adslAturChanIntvlStruct.IntervalNumber= (*(int *)ret_len);
    SET_FLAG(&adslAturChanIntvlStruct.flags, ATUR_CHAN_INTVL_CORR_BLK_FLAG);

#ifdef ENABLE_DRIVER_CALL
    adsl_ioctl(Fd, GET_ADSL_ATUR_CHAN_INTVL_INFO, &adslAturChanIntvlStruct);
#else
    get_adslAturChanIntervalTable(Fd, GET_ADSL_ATUR_CHAN_INTVL_INFO,
        (void *) &adslAturChanIntvlStruct);
#endif
    if (IS_FLAG_SET(&adslAturChanIntvlStruct.flags,
        ATUR_CHAN_INTVL_CORR_BLK_FLAG) == 0) 
       DEBUGMSGTL(("adslMIB-ATUR", "ChanIntvlCorrBlk CMV fail\n"));

    CLR_FLAG(&adslAturChanIntvlStruct.flags, ATUR_CHAN_INTVL_CORR_BLK_FLAG);
    long_ret = adslAturChanIntvlStruct.chanIntervalCorrectedBlks;
    *ret_len = sizeof(adslAturChanIntvlStruct.chanIntervalCorrectedBlks);
    return (u_int32 *) &long_ret;
}

/** XXX: return a data pointer to the data for the
    adslAturChanIntervalUncorrectBlks column and set ret_len to its
    proper size in bytes. */
u_int32  *
get_adslAturChanIntervalUncorrectBlks(void *data_context,
                                       size_t * ret_len)
{
    struct adslAturChanIntvlInfo adslAturChanIntvlStruct;

    memset(&adslAturChanIntvlStruct,0,sizeof(adslAturChanIntvlInfo));
    adslAturChanIntvlStruct.ifIndex= (*(int *)data_context);
    adslAturChanIntvlStruct.IntervalNumber= (*(int *)ret_len);
    SET_FLAG(&adslAturChanIntvlStruct.flags, ATUR_CHAN_INTVL_UNCORR_BLK_FLAG);

#ifdef ENABLE_DRIVER_CALL
    adsl_ioctl(Fd, GET_ADSL_ATUR_CHAN_INTVL_INFO, &adslAturChanIntvlStruct);
#else
    get_adslAturChanIntervalTable(Fd, GET_ADSL_ATUR_CHAN_INTVL_INFO,
        (void *) &adslAturChanIntvlStruct);
#endif
    if (IS_FLAG_SET(&adslAturChanIntvlStruct.flags,
        ATUR_CHAN_INTVL_UNCORR_BLK_FLAG) == 0) 
       DEBUGMSGTL(("adslMIB-ATUR", "ChanIntvlUnCorrBlk CMV fail\n"));

    CLR_FLAG(&adslAturChanIntvlStruct.flags, ATUR_CHAN_INTVL_UNCORR_BLK_FLAG);
    long_ret = adslAturChanIntvlStruct.chanIntervalUncorrectBlks;
    *ret_len = sizeof(adslAturChanIntvlStruct.chanIntervalUncorrectBlks);
    return (u_int32 *) &long_ret;
}

#endif

/** XXX: return a data pointer to the data for the adslAturChanIntervalValidData
    column and set ret_len to its proper size in bytes. */
int    *
get_adslAturChanIntervalValidData(void *data_context, size_t * ret_len)
{
    struct adslAturChanIntvlInfo adslAturChanIntvlStruct;

    memset(&adslAturChanIntvlStruct,0,sizeof(adslAturChanIntvlInfo));
    adslAturChanIntvlStruct.ifIndex= (*(int *)data_context);
    adslAturChanIntvlStruct.IntervalNumber= (*(int *)ret_len);
    SET_FLAG(&adslAturChanIntvlStruct.flags, ATUR_CHAN_INTVL_VALID_DATA_FLAG);

#ifdef ENABLE_DRIVER_CALL
    adsl_ioctl(Fd, GET_ADSL_ATUR_CHAN_INTVL_INFO, &adslAturChanIntvlStruct);
#else
    get_adslAturChanIntervalTable(Fd, GET_ADSL_ATUR_CHAN_INTVL_INFO,
        (void *) &adslAturChanIntvlStruct);
#endif
    if (IS_FLAG_SET(&adslAturChanIntvlStruct.flags,
        ATUR_CHAN_INTVL_VALID_DATA_FLAG) == 0) 
       DEBUGMSGTL(("adslMIB-ATUR", "ChanIntvlValidData CMV fail\n"));

    CLR_FLAG(&adslAturChanIntvlStruct.flags, ATUR_CHAN_INTVL_VALID_DATA_FLAG);
    long_ret = adslAturChanIntvlStruct.intervalValidData;
    *ret_len = sizeof(adslAturChanIntvlStruct.intervalValidData);
    return (int *) &long_ret;
}

#ifndef ENABLE_DRIVER_CALL
int  get_adslAturChanIntervalTable(int Fd2, int GET_ADSL_atur_CHAN_INTVL_INFO,
            void *adslAturChanIntvlTable)
{
    struct adslAturChanIntvlInfo *adslAturChanIntvlValue;
    adslAturChanIntvlValue = (adslAturChanIntvlInfo *)adslAturChanIntvlTable;
    adslAturChanIntvlValue->chanIntervalRecvdBlks = 100;
    adslAturChanIntvlValue->chanIntervalXmitBlks = 200;
    adslAturChanIntvlValue->chanIntervalCorrectedBlks = 300;
    adslAturChanIntvlValue->chanIntervalUncorrectBlks = 50;
    adslAturChanIntvlValue->intervalValidData = 2;
    return 0;
}
#endif

