/* ============================================================================
 * Copyright (C) 2004 - Infineon Technologies AG.
 *
 * All rights reserved.
 * ============================================================================
 *
 * ============================================================================
 *
 * This document contains proprietary information belonging to Infineon
 * Technologies AG. Passing on and copying of this document, and communication
 * of its contents is not permitted without prior written authorisation.
 *
 * ============================================================================
 */

/* ===========================================================================
 *
 * File Name    : adslAturChanIntervalTable_access.h
 * Author       : Subbi
 * Date         : 17-Jun-2004
 *
 * ===========================================================================
 *
 * Project      : Amazon
 * Block        : ADSL-MIBs
 *
 * ===========================================================================
 * Contents: This file contains:
 *                 1) User-defined data structure for accessing
 *                    adslAturChanIntervalTable
 *                 2) User-defined data access functions for data in table
 *                    adslAturChanIntervalTable
 *                 3) Column accessors functions
 *
 *
 * ===========================================================================
 * References: RFC 2662
 *
 */

/* ===========================================================================
 * Revision History:
 * Subramani:  29-Jun04 Changed the return type for intervalValidData
 * $Log$
 * ===========================================================================
 */

/*
 * Note: this file originally auto-generated by mib2c using
 *        : mib2c.access_functions.conf,v 1.6 2003/09/11 22:48:49 rstory Exp $
 */

#ifndef ADSLATURCHANINTERVALTABLE_ACCESS_H
#define ADSLATURCHANINTERVALTABLE_ACCESS_H

/*
 * ===========================================================================
 *                           INCLUDE FILES
 * ===========================================================================
 */
#include <adslMIB/adslTable_access.h>

/*
 * ===========================================================================
 *                           USER-DEFINED DATA TYPES
 * ===========================================================================
 */
#ifdef STUB_IOCTL
/** User-defined data structure for accessing adslAturChanIntervalTable **/
#define PerfIntervalCount u_int32

typedef struct adslAturChanIntvlInfo {
    int ifIndex;
    int IntervalNumber;
    PerfIntervalCount chanIntervalRecvdBlks;
    PerfIntervalCount chanIntervalXmitBlks;
    PerfIntervalCount chanIntervalCorrectedBlks;
    PerfIntervalCount chanIntervalUncorrectBlks;
    int intervalValidData;
u_char flags;
} adslAturChanIntvlInfo;
#endif

/*
 * ===========================================================================
 *                           FUNCTION PROTOTYPES
 * ===========================================================================
 */
/** User-defined data access functions for data in table
    adslAturChanIntervalTable */
/** row level accessors */
Netsnmp_First_Data_Point adslAturChanIntervalTable_get_first_data_point;
Netsnmp_Next_Data_Point adslAturChanIntervalTable_get_next_data_point;


/** column accessors */
#if defined(HAVE_OPTIMIZED_CODE)
u_int32  *
get_adslAturChanIntervalData(void *data_context, size_t * ret_len, 
		unsigned int var);
#else
u_int32 *get_adslAturChanIntervalReceivedBlks(void *data_context,
            size_t * ret_len);
u_int32 *get_adslAturChanIntervalTransmittedBlks(void *data_context,
            size_t * ret_len);
u_int32 *get_adslAturChanIntervalCorrectedBlks(void *data_context,
            size_t * ret_len);
u_int32 *get_adslAturChanIntervalUncorrectBlks(void *data_context,
            size_t * ret_len);
#endif

int    *get_adslAturChanIntervalValidData(void *data_context,
            size_t * ret_len);

#ifndef ENABLE_DRIVER_CALL
int  get_adslAturChanIntervalTable(int Fd2,int GET_ADSL_atur_CHAN_INTVL_INFO,
            void *adslAturChanIntvlTable);
#endif

#endif                          /* ADSLATURCHANINTERVALTABLE_ACCESS_H */
