/* ============================================================================
 * Copyright (C) 2004 - Infineon Technologies AG.
 *
 * All rights reserved.
 * ============================================================================
 *
 * ============================================================================
 *
 * This document contains proprietary information belonging to Infineon
 * Technologies AG. Passing on and copying of this document, and communication
 * of its contents is not permitted without prior written authorisation.
 *
 * ============================================================================
 */

/* ===========================================================================
 *
 * File Name    :   adslLineAlarmConfProfileTable_access.c
 * Author       :   Subramani
 * Date         :   17-Jun-2004
 *
 * ===========================================================================
 *
 * Project      :   Amazon
 * Block        :   ADSL-MIBs
 *
 * ===========================================================================
 * Contents: This file contains functions for:
 *                  1) Getting the data context pointer & loop context
 *                  pointer
 *                  2) User-defined data access functions (per column) for data
 *                  in table adslLineAlarmConfProfileTable
 *
 *
 * ===========================================================================
 * References: RFC 2662
 *
 */



/* ===========================================================================
 * Revision History:
 * Subramani: Changed data types as per Rfc-2662
 *
 * $Log$
 * ===========================================================================
 */
/*
 * Note: this file originally auto-generated by mib2c using
 *        : mib2c.access_functions.conf,v 1.6 2003/09/11 22:48:49 rstory Exp $
 */

/*
 * ===========================================================================
 *                           INCLUDE FILES
 * ===========================================================================
*/

#include <net-snmp/net-snmp-config.h>
#include <net-snmp/net-snmp-includes.h>
#include <net-snmp/agent/net-snmp-agent-includes.h>
#include "adslLineAlarmConfProfileTable_access.h"
#include "adslLineAlarmConfProfileTable_enums.h"

/* column number definitions for table adslLineAlarmConfProfileTable */
#include "adslLineAlarmConfProfileTable_columns.h"

/*
 * ===========================================================================
 *                          GLOBAL DEFINITIONS
 * ===========================================================================
*/

/* Global decalarations */
static u_int32 long_ret;

#ifndef ENABLE_DRIVER_CALL

static int     adslAtucTh15MinLofs=10;
static int     adslAtucTh15MinLoss=20;
static int     adslAtucTh15MinESs=30;
static u_int32     adslAtucThFastRateUp=40;
static u_int32     adslAtucThInterleaveRateUp=50;
static u_int32     adslAtucThFastRateDown=60;
static u_int32     adslAtucThInterleaveRateDown=70;
static int     adslAtucInitFailTrapEnable=80;
static int     adslAturTh15MinLofs=90;
static int     adslAturTh15MinLoss=100;
static int     adslAturTh15MinLprs=110;
static int     adslAturTh15MinESs=120;
static u_int32     adslAturThFastRateUp=130;
static u_int32     adslAturThInterleaveRateUp=140;
static u_int32     adslAturThFastRateDown=150;
static u_int32     adslAturThInterleaveRateDown=160;
static int     adslLineAlarmConfProfRowStatus=1;

#endif

/*
 * ===========================================================================
 *                          LOCAL FUNCTIONS
 * ===========================================================================
*/

/** returns the first data point within the adslLineAlarmConfProfileTable
    table data.

    Set the my_loop_context variable to the first data point structure
    of your choice (from which you can find the next one).  This could
    be anything from the first node in a linked list, to an integer
    pointer containing the beginning of an array variable.

    Set the my_data_context variable to something to be returned to
    you later that will provide you with the data to return in a given
    row.  This could be the same pointer as what my_loop_context is
    set to, or something different.

    The put_index_data variable contains a list of snmp variable
    bindings, one for each index in your table.  Set the values of
    each appropriately according to the data matching the first row
    and return the put_index_data variable at the end of the function.
*/
netsnmp_variable_list *
adslLineAlarmConfProfileTable_get_first_data_point(void **my_loop_context,
                                                   void **my_data_context,
                                                   netsnmp_variable_list *
                                                   put_index_data,
                                                   netsnmp_iterator_info
                                                   *mydata)
{

    int *My_Data_Context;
    My_Data_Context = SNMP_MALLOC_TYPEDEF(int);
    if (!My_Data_Context) {
        put_index_data = NULL;
        snmp_log(LOG_ERR, "Get-First: adslLineAlarmConfProfileTable: My_Data_Context malloc failed\n");
        return put_index_data;
    }

    *My_Data_Context=IFTYPE_ADSL;
    *my_data_context=My_Data_Context;

    put_index_data = adslAlarmTable_get_first_data_point(my_loop_context,
                                   my_data_context,
                                   put_index_data,
                                   mydata);

    SNMP_FREE(My_Data_Context);
    return put_index_data;
}

/** functionally the same as adslLineAlarmConfProfileTable_get_first_data_point
   , but my_loop_context has already been set to a previous value and should
   be updated to the next in the list.  For example, if it was a
   linked list, you might want to cast it to your local data type and
   then return my_loop_context->next.  The my_data_context pointer
   should be set to something you need later and the indexes in
   put_index_data updated again. */
netsnmp_variable_list *
adslLineAlarmConfProfileTable_get_next_data_point(void **my_loop_context,
                                                  void **my_data_context,
                                                  netsnmp_variable_list *
                                                  put_index_data,
                                                  netsnmp_iterator_info
                                                  *mydata)
{
    int *My_Data_Context;
    My_Data_Context = SNMP_MALLOC_TYPEDEF(int);
    if (!My_Data_Context) {
        put_index_data = NULL;
        snmp_log(LOG_ERR, "Get-Next: adslLineAlarmConfProfileTable: My_Data_Context malloc failed\n");
        return put_index_data;
    }

    *My_Data_Context=IFTYPE_ADSL;
    *my_data_context=My_Data_Context;

    put_index_data = adslAlarmTable_get_next_data_point(my_loop_context,
                                   my_data_context,
                                   put_index_data,
                                   mydata);

    SNMP_FREE(My_Data_Context);
    return put_index_data;
}

/** Create a data_context for non-existent rows that SETs are performed on.
 *  return a void * pointer which will be passed to subsequent get_XXX
 *  and set_XXX functions for data retrival and modification during
 *  this SET request.
 *
 *  The indexs are encoded (in order) into the index_data pointer if it
 *  would be helpful to use that information.
 */
void           *
adslLineAlarmConfProfileTable_create_data_context(netsnmp_variable_list *
                                                  index_data)
{
    return NULL;            /* XXX: you likely want to return a real pointer */
}

/** If the implemented set_* functions don't operate directly on the
   real-live data (which is actually recommended), then this function
   can be used to take a given my_data_context pointer and "commit" it
   to whereever the modified data needs to be put back to.  For
   example, if this was a routing table you could publish the modified
   routes back into the kernel at this point.

   new_or_del will be set to 1 if new, or -1 if it should be deleted
   or 0 if it is just a modification of an existing row.

   If you free the data yourself, make sure to *my_data_context = NULL */
int
adslLineAlarmConfProfileTable_commit_row(void **my_data_context,
                                         int new_or_del)
{
    /** Add any necessary commit code here */
    /*
     */

    /*
     * return no errors.  And there shouldn't be any!!!  Ever!!!  You
     * should have checked the values long before this.
     */
    return SNMP_ERR_NOERROR;
}


/*
 * User-defined data access functions (per column) for data in table
 adslLineAlarmConfProfileTable
 */
/*
 * NOTE:
 * - these get_ routines MUST return data that will not be freed (ie,
 *   use static variables or persistent data).  It will be copied, if
 *   needed, immediately after the get_ routine has been called.
 * - these SET routines must copy the incoming data and can not take
 *   ownership of the memory passed in by the val pointer.
 */
/** XXX: return a data pointer to the data for the adslAtucThresh15MinLofs
     column and set ret_len to its proper size in bytes. */
#if defined(HAVE_OPTIMIZED_CODE)
int *
get_adslThresh15MinVal(void *data_context, size_t *ret_len, unsigned int var)
{
  unsigned int flags = 0;
  struct adslLineAlarmConfProfileEntry adslLineAlarmConfProStruct;
  memset(&adslLineAlarmConfProStruct,0,sizeof(adslLineAlarmConfProfileEntry));
  strcpy(adslLineAlarmConfProStruct.adslLineAlarmConfProfileName,
          (char *)data_context);
  switch (var)
  {
     case COLUMN_ADSLATUCTHRESH15MINLOFS:
    	flags = ATUC_THRESH_15MIN_LOFS_FLAG;
	break;
	
     case COLUMN_ADSLATUCTHRESH15MINLOSS:
    	flags =  ATUC_THRESH_15MIN_LOSS_FLAG;
	break;
	
     case COLUMN_ADSLATUCTHRESH15MINESS:
    	flags =  ATUC_THRESH_15MIN_ESS_FLAG;
	break;

     case COLUMN_ADSLATURTHRESH15MINLOFS:
        flags = ATUR_THRESH_15MIN_LOFS_FLAG;
	break;

     case COLUMN_ADSLATURTHRESH15MINLOSS:
    	flags =  ATUR_THRESH_15MIN_LOSS_FLAG;
	break;

     case COLUMN_ADSLATURTHRESH15MINLPRS:
    	flags =  ATUR_THRESH_15MIN_LPRS_FLAG;
	break;

     case COLUMN_ADSLATURTHRESH15MINESS:
    	flags =  ATUR_THRESH_15MIN_ESS_FLAG;
	break;

     case COLUMN_ADSLATUCINITFAILURETRAPENABLE:
    	flags =  ATUC_INIT_FAILURE_TRAP_ENABLE_FLAG;
	break;
	
     case COLUMN_ADSLLINEALARMCONFPROFILEROWSTATUS:
    	flags = LINE_ALARM_CONF_PROFILE_ROWSTATUS_FLAG;
	break;
    
     default:
     DEBUGMSGTL(("Unknown MIB variable requested!", "\n"));
     break;
   }

   SET_FLAG(&adslLineAlarmConfProStruct.flags, flags);
#ifdef ENABLE_DRIVER_CALL
    adsl_ioctl(Fd, GET_ADSL_ALRM_CONF_PROF,(void *) &adslLineAlarmConfProStruct);
#else
    adslLineAlarmConfProfileTable(Fd, GET_ADSL_ALRM_CONF_PROF,
        (void *) &adslLineAlarmConfProStruct);
#endif
    if (IS_FLAG_SET(&adslLineAlarmConfProStruct.flags, flags) == 0) 
     DEBUGMSGTL(("adslMIB-Line", "GET- %x CMV fail\n", flags));

  switch (flags)
  {
     case ATUC_THRESH_15MIN_LOFS_FLAG:
    	long_ret = adslLineAlarmConfProStruct.adslAtucThresh15MinLofs;
	break;
	
     case ATUC_THRESH_15MIN_LOSS_FLAG:
    	long_ret = adslLineAlarmConfProStruct.adslAtucThresh15MinLoss;
	break;
	
     case ATUC_THRESH_15MIN_ESS_FLAG:
    	long_ret = adslLineAlarmConfProStruct.adslAtucThresh15MinESs;
	break;

     case ATUR_THRESH_15MIN_LOFS_FLAG:
    	long_ret = adslLineAlarmConfProStruct.adslAturThresh15MinLofs;
	break;

     case ATUR_THRESH_15MIN_LOSS_FLAG:
    	long_ret = adslLineAlarmConfProStruct.adslAturThresh15MinLoss;
	break;

     case ATUR_THRESH_15MIN_LPRS_FLAG:
    	long_ret = adslLineAlarmConfProStruct.adslAturThresh15MinLprs;
	break;

     case ATUR_THRESH_15MIN_ESS_FLAG:
    	long_ret = adslLineAlarmConfProStruct.adslAturThresh15MinESs;
	break;

     case ATUC_INIT_FAILURE_TRAP_ENABLE_FLAG:
    	long_ret = adslLineAlarmConfProStruct.adslAtucInitFailureTrapEnable;
	break;
	
     case LINE_ALARM_CONF_PROFILE_ROWSTATUS_FLAG:
    	long_ret = adslLineAlarmConfProStruct.adslLineAlarmConfProfileRowStatus;
	break;
    
     default:
     DEBUGMSGTL(("Unknown MIB variable requested!", "\n"));
     return NULL;
   }
  
   CLR_FLAG(&adslLineAlarmConfProStruct.flags, flags);
   *ret_len = sizeof(int);
   return (int *) &long_ret;
}


int 
set_adslThresh15MinVal(void *data_context, long *val, 
		size_t val_len, unsigned int var)
{
  unsigned int flags = 0;
  struct adslLineAlarmConfProfileEntry adslLineAlarmConfProStruct;
  memset(&adslLineAlarmConfProStruct,0,sizeof(adslLineAlarmConfProfileEntry));
  strcpy(adslLineAlarmConfProStruct.adslLineAlarmConfProfileName,
          (char *)data_context);
  switch (var)
  {
     case COLUMN_ADSLATUCTHRESH15MINLOFS:
    	flags = ATUC_THRESH_15MIN_LOFS_FLAG;
    	adslLineAlarmConfProStruct.adslAtucThresh15MinLofs = *val;
	break;
	
     case COLUMN_ADSLATUCTHRESH15MINLOSS:
    	flags =  ATUC_THRESH_15MIN_LOSS_FLAG;
    	adslLineAlarmConfProStruct.adslAtucThresh15MinLoss = *val;
	break;
	
     case COLUMN_ADSLATUCTHRESH15MINESS:
    	flags =  ATUC_THRESH_15MIN_ESS_FLAG;
    	adslLineAlarmConfProStruct.adslAtucThresh15MinESs = *val;
	break;

     case COLUMN_ADSLATURTHRESH15MINLOFS:
        flags = ATUR_THRESH_15MIN_LOFS_FLAG;
    	adslLineAlarmConfProStruct.adslAturThresh15MinLofs = *val;
	break;

     case COLUMN_ADSLATURTHRESH15MINLOSS:
    	flags =  ATUR_THRESH_15MIN_LOSS_FLAG;
    	adslLineAlarmConfProStruct.adslAturThresh15MinLoss = *val;
	break;

     case COLUMN_ADSLATURTHRESH15MINLPRS:
    	flags =  ATUR_THRESH_15MIN_LPRS_FLAG;
    	adslLineAlarmConfProStruct.adslAturThresh15MinLprs=*val;
	break;

     case COLUMN_ADSLATURTHRESH15MINESS:
    	flags =  ATUR_THRESH_15MIN_ESS_FLAG;
    	adslLineAlarmConfProStruct.adslAturThresh15MinESs=*val;
	break;

     case COLUMN_ADSLATUCINITFAILURETRAPENABLE:
    	flags =  ATUC_INIT_FAILURE_TRAP_ENABLE_FLAG;
    	adslLineAlarmConfProStruct.adslAtucInitFailureTrapEnable=*val;
	break;
	
     case COLUMN_ADSLLINEALARMCONFPROFILEROWSTATUS:
    	return SNMP_ERR_NOTWRITABLE;      /** XXX: change if an error occurs */
    
     default:
     DEBUGMSGTL(("Unknown MIB variable requested!", "\n"));
     return SNMP_ERR_NOSUCHNAME;

   }
   SET_FLAG(&adslLineAlarmConfProStruct.flags, flags);
#ifdef ENABLE_DRIVER_CALL
    adsl_ioctl(Fd, SET_ADSL_ALRM_CONF_PROF,(void *) &adslLineAlarmConfProStruct);
#else
    adslLineAlarmConfProfileTable(Fd, SET_ADSL_ALRM_CONF_PROF,
        (void *) &adslLineAlarmConfProStruct);
#endif
    if (IS_FLAG_SET(&adslLineAlarmConfProStruct.flags, flags) == 0) {
      	DEBUGMSGTL(("adslMIB-Line", "SET- %d CMV fail\n", flags));
     	CLR_FLAG(&adslLineAlarmConfProStruct.flags, flags);
        return SNMP_ERR_COMMITFAILED;
    }
    else {
        CLR_FLAG(&adslLineAlarmConfProStruct.flags, flags);
        return SNMP_ERR_NOERROR;
    }
}


u_int32         *
get_adslThreshChanVal(void *data_context, size_t *ret_len, unsigned int var)
{
  unsigned int flags = 0;
  struct adslLineAlarmConfProfileEntry adslLineAlarmConfProStruct;
  memset(&adslLineAlarmConfProStruct,0,sizeof(adslLineAlarmConfProfileEntry));
  strcpy(adslLineAlarmConfProStruct.adslLineAlarmConfProfileName,
          (char *)data_context);
  switch (var)
  {
     case COLUMN_ADSLATUCTHRESHFASTRATEUP:
    	flags = ATUC_THRESH_FAST_RATEUP_FLAG;
	break;
	
     case COLUMN_ADSLATUCTHRESHINTERLEAVERATEUP:
    	flags = ATUC_THRESH_INTERLEAVE_RATEUP_FLAG;
	break;
	
     case COLUMN_ADSLATUCTHRESHFASTRATEDOWN:
    	flags = ATUC_THRESH_FAST_RATEDOWN_FLAG;
	break;

     case COLUMN_ADSLATUCTHRESHINTERLEAVERATEDOWN:
        flags = ATUC_THRESH_INTERLEAVE_RATEDOWN_FLAG;
	break;

     case COLUMN_ADSLATURTHRESHFASTRATEUP:
    	flags = ATUR_THRESH_FAST_RATEUP_FLAG;
	break;

     case COLUMN_ADSLATURTHRESHINTERLEAVERATEUP:
    	flags = ATUR_THRESH_INTERLEAVE_RATEUP_FLAG;
	break;

     case COLUMN_ADSLATURTHRESHFASTRATEDOWN:
    	flags = ATUR_THRESH_FAST_RATEDOWN_FLAG;
	break;

     case COLUMN_ADSLATURTHRESHINTERLEAVERATEDOWN:
        flags = ATUR_THRESH_INTERLEAVE_RATEDOWN_FLAG;
	break;
	
     default:
     DEBUGMSGTL(("Unknown MIB variable requested!", "\n"));
     return NULL;

   }
  
   SET_FLAG(&adslLineAlarmConfProStruct.flags, flags);
#ifdef ENABLE_DRIVER_CALL
    adsl_ioctl(Fd, GET_ADSL_ALRM_CONF_PROF,(void *) &adslLineAlarmConfProStruct);
#else
    adslLineAlarmConfProfileTable(Fd, GET_ADSL_ALRM_CONF_PROF,
        (void *) &adslLineAlarmConfProStruct);
#endif
   if (IS_FLAG_SET(&adslLineAlarmConfProStruct.flags,flags) == 0) 
      DEBUGMSGTL(("adslMIB-Line", "LineAlarmConfProf: GET- %x CMV fail\n", flags));

  switch (flags)
  {
     case ATUC_THRESH_FAST_RATEUP_FLAG:
    	long_ret = adslLineAlarmConfProStruct.adslAtucThreshFastRateUp;
	break;
	
     case ATUC_THRESH_INTERLEAVE_RATEUP_FLAG:
    	long_ret = adslLineAlarmConfProStruct.adslAtucThreshInterleaveRateUp;
	break;
	
     case ATUC_THRESH_FAST_RATEDOWN_FLAG:
    	long_ret = adslLineAlarmConfProStruct.adslAtucThreshFastRateDown;
	break;

     case ATUC_THRESH_INTERLEAVE_RATEDOWN_FLAG:
    	long_ret = adslLineAlarmConfProStruct.adslAtucThreshInterleaveRateDown;
	break;

     case ATUR_THRESH_FAST_RATEUP_FLAG:
    	long_ret = adslLineAlarmConfProStruct.adslAturThreshFastRateUp;
	break;

     case ATUR_THRESH_INTERLEAVE_RATEUP_FLAG:
    	long_ret = adslLineAlarmConfProStruct.adslAturThreshInterleaveRateUp;
	break;
	
     case ATUR_THRESH_FAST_RATEDOWN_FLAG:
    	long_ret = adslLineAlarmConfProStruct.adslAturThreshFastRateDown;
	break;

     case ATUR_THRESH_INTERLEAVE_RATEDOWN_FLAG:
    	long_ret = adslLineAlarmConfProStruct.adslAturThreshInterleaveRateDown;
	break;

     default:
     DEBUGMSGTL(("Unknown MIB variable requested!", "\n"));
     return NULL;
   }

   CLR_FLAG(&adslLineAlarmConfProStruct.flags, flags);
   *ret_len = sizeof(u_int32);
   return (u_int32 *) &long_ret;
}


int 
set_adslThreshChanVal(void *data_context, long *val, 
		size_t val_len, unsigned int var)
{
  unsigned int flags = 0;
  struct adslLineAlarmConfProfileEntry adslLineAlarmConfProStruct;
  memset(&adslLineAlarmConfProStruct,0,sizeof(adslLineAlarmConfProfileEntry));
  strcpy(adslLineAlarmConfProStruct.adslLineAlarmConfProfileName,
          (char *)data_context);
  switch (var)
  {
     case COLUMN_ADSLATUCTHRESHFASTRATEUP:
    	flags = ATUC_THRESH_FAST_RATEUP_FLAG;
    	adslLineAlarmConfProStruct.adslAtucThreshFastRateUp=*val;
	break;
	
     case COLUMN_ADSLATUCTHRESHINTERLEAVERATEUP:
    	flags = ATUC_THRESH_INTERLEAVE_RATEUP_FLAG;
    	adslLineAlarmConfProStruct.adslAtucThreshInterleaveRateUp=*val;
	break;
	
     case COLUMN_ADSLATUCTHRESHFASTRATEDOWN:
    	flags = ATUC_THRESH_FAST_RATEDOWN_FLAG;
    	adslLineAlarmConfProStruct.adslAtucThreshFastRateDown=*val;
	break;

     case COLUMN_ADSLATUCTHRESHINTERLEAVERATEDOWN:
        flags = ATUC_THRESH_INTERLEAVE_RATEDOWN_FLAG;
    	adslLineAlarmConfProStruct.adslAtucThreshInterleaveRateDown=*val;
	break;

     case COLUMN_ADSLATURTHRESHFASTRATEUP:
    	flags = ATUR_THRESH_FAST_RATEUP_FLAG;
    	adslLineAlarmConfProStruct.adslAturThreshFastRateUp=*val;
	break;

     case COLUMN_ADSLATURTHRESHINTERLEAVERATEUP:
    	flags = ATUR_THRESH_INTERLEAVE_RATEUP_FLAG;
    	adslLineAlarmConfProStruct.adslAturThreshInterleaveRateUp=*val;
	break;

     case COLUMN_ADSLATURTHRESHFASTRATEDOWN:
    	flags = ATUR_THRESH_FAST_RATEDOWN_FLAG;
    	adslLineAlarmConfProStruct.adslAturThreshFastRateDown=*val;
	break;

     case COLUMN_ADSLATURTHRESHINTERLEAVERATEDOWN:
        flags = ATUR_THRESH_INTERLEAVE_RATEDOWN_FLAG;
    	adslLineAlarmConfProStruct.adslAturThreshInterleaveRateDown=*val;
	break;
	
     default:
     DEBUGMSGTL(("Unknown MIB variable requested!", "\n"));
     return SNMP_ERR_NOSUCHNAME;

   }
   SET_FLAG(&adslLineAlarmConfProStruct.flags, flags);
#ifdef ENABLE_DRIVER_CALL
    adsl_ioctl(Fd, SET_ADSL_ALRM_CONF_PROF,(void *) &adslLineAlarmConfProStruct);
#else
    adslLineAlarmConfProfileTable(Fd, SET_ADSL_ALRM_CONF_PROF,
        (void *) &adslLineAlarmConfProStruct);
#endif
    if (IS_FLAG_SET(&adslLineAlarmConfProStruct.flags, flags) == 0) {
      	DEBUGMSGTL(("adslMIB-Line", "SET- %d CMV fail\n", flags));
     	CLR_FLAG(&adslLineAlarmConfProStruct.flags, flags);
        return SNMP_ERR_COMMITFAILED;
    }
    else {
        CLR_FLAG(&adslLineAlarmConfProStruct.flags, flags);
        return SNMP_ERR_NOERROR;
    }
}

#else

int           *
get_adslAtucThresh15MinLofs(void *data_context, size_t * ret_len)
{

    struct adslLineAlarmConfProfileEntry adslLineAlarmConfProStruct;
    memset(&adslLineAlarmConfProStruct,0,sizeof(adslLineAlarmConfProfileEntry));
    strcpy(adslLineAlarmConfProStruct.adslLineAlarmConfProfileName,
            (char *)data_context);
    SET_FLAG(&adslLineAlarmConfProStruct.flags, ATUC_THRESH_15MIN_LOFS_FLAG);

#ifdef ENABLE_DRIVER_CALL
    adsl_ioctl(Fd, GET_ADSL_ALRM_CONF_PROF,(void *) &adslLineAlarmConfProStruct);
#else
    adslLineAlarmConfProfileTable(Fd, GET_ADSL_ALRM_CONF_PROF,
            (void *) &adslLineAlarmConfProStruct);
#endif
    if (IS_FLAG_SET(&adslLineAlarmConfProStruct.flags,
            ATUC_THRESH_15MIN_LOFS_FLAG) == 0) 
       DEBUGMSGTL(("adslMIB-Line", "GET- AtucThresh15MinLOF CMV fail\n"));

    CLR_FLAG(&adslLineAlarmConfProStruct.flags, ATUC_THRESH_15MIN_LOFS_FLAG);
    long_ret = adslLineAlarmConfProStruct.adslAtucThresh15MinLofs;
    *ret_len = sizeof(adslLineAlarmConfProStruct.adslAtucThresh15MinLofs);
    return (int *) &long_ret;
}
/** XXX: Set the value of the adslAtucThresh15MinLofs column and return
         SNMPERR_SUCCESS on success
         SNMPERR_XXX     for SNMP deterministic error codes
         SNMPERR_GENERR  on generic failures (a last result response). */
int
set_adslAtucThresh15MinLofs(void *data_context, long *val, size_t val_len)
{
    struct adslLineAlarmConfProfileEntry adslLineAlarmConfProStruct;
    memset(&adslLineAlarmConfProStruct,0,sizeof(adslLineAlarmConfProfileEntry));
    strcpy(adslLineAlarmConfProStruct.adslLineAlarmConfProfileName,
            (char *)data_context);
    adslLineAlarmConfProStruct.adslAtucThresh15MinLofs=*val;
    SET_FLAG(&adslLineAlarmConfProStruct.flags, ATUC_THRESH_15MIN_LOFS_FLAG);

#ifdef ENABLE_DRIVER_CALL
    adsl_ioctl(Fd, SET_ADSL_ALRM_CONF_PROF,(void *) &adslLineAlarmConfProStruct);
#else
    adslLineAlarmConfProfileTable(Fd, SET_ADSL_ALRM_CONF_PROF,
            (void *) &adslLineAlarmConfProStruct);
#endif
    if (IS_FLAG_SET(&adslLineAlarmConfProStruct.flags,
            ATUC_THRESH_15MIN_LOFS_FLAG) == 0) {
      DEBUGMSGTL(("adslMIB-Line", "SET- AtucThresh15MinLOF CMV fail\n"));
      CLR_FLAG(&adslLineAlarmConfProStruct.flags, ATUC_THRESH_15MIN_LOFS_FLAG);
      return SNMP_ERR_COMMITFAILED;
    }
    else {
        CLR_FLAG(&adslLineAlarmConfProStruct.flags, ATUC_THRESH_15MIN_LOFS_FLAG);
        return SNMP_ERR_NOERROR;
   }

}

/** XXX: return a data pointer to the data for the adslAtucThresh15MinLoss
    column and set ret_len to its proper size in bytes. */
int           *
get_adslAtucThresh15MinLoss(void *data_context, size_t * ret_len)
{
    struct adslLineAlarmConfProfileEntry adslLineAlarmConfProStruct;
    memset(&adslLineAlarmConfProStruct,0,sizeof(adslLineAlarmConfProfileEntry));
    strcpy(adslLineAlarmConfProStruct.adslLineAlarmConfProfileName,
        (char *)data_context);
    SET_FLAG(&adslLineAlarmConfProStruct.flags, ATUC_THRESH_15MIN_LOSS_FLAG);

#ifdef ENABLE_DRIVER_CALL
    adsl_ioctl(Fd, GET_ADSL_ALRM_CONF_PROF,(void *) &adslLineAlarmConfProStruct);
#else
    adslLineAlarmConfProfileTable(Fd, GET_ADSL_ALRM_CONF_PROF,
        (void *) &adslLineAlarmConfProStruct);
#endif
    if (IS_FLAG_SET(&adslLineAlarmConfProStruct.flags,
        ATUC_THRESH_15MIN_LOSS_FLAG) == 0) 
      DEBUGMSGTL(("adslMIB-Line", "GET- AtucThresh15MinLOSS CMV fail\n"));

    CLR_FLAG(&adslLineAlarmConfProStruct.flags, ATUC_THRESH_15MIN_LOSS_FLAG);
    long_ret = adslLineAlarmConfProStruct.adslAtucThresh15MinLoss;
    *ret_len = sizeof(adslLineAlarmConfProStruct.adslAtucThresh15MinLoss);
    return (int *) &long_ret;
}

/** XXX: Set the value of the adslAtucThresh15MinLoss column and return
         SNMPERR_SUCCESS on success
         SNMPERR_XXX     for SNMP deterministic error codes
         SNMPERR_GENERR  on generic failures (a last result response). */
int
set_adslAtucThresh15MinLoss(void *data_context, long *val, size_t val_len)
{
    struct adslLineAlarmConfProfileEntry adslLineAlarmConfProStruct;
    memset(&adslLineAlarmConfProStruct,0,sizeof(adslLineAlarmConfProfileEntry));
    strcpy(adslLineAlarmConfProStruct.adslLineAlarmConfProfileName,
            (char *)data_context);
    adslLineAlarmConfProStruct.adslAtucThresh15MinLoss=*val;
    SET_FLAG(&adslLineAlarmConfProStruct.flags, ATUC_THRESH_15MIN_LOSS_FLAG);

#ifdef ENABLE_DRIVER_CALL
    adsl_ioctl(Fd, SET_ADSL_ALRM_CONF_PROF,(void *) &adslLineAlarmConfProStruct);
#else
    adslLineAlarmConfProfileTable(Fd, SET_ADSL_ALRM_CONF_PROF,
        (void *) &adslLineAlarmConfProStruct);
#endif
    if (IS_FLAG_SET(&adslLineAlarmConfProStruct.flags,
            ATUC_THRESH_15MIN_LOSS_FLAG) == 0) {
      DEBUGMSGTL(("adslMIB-Line", "SET- AtucThresh15MinLOSS CMV fail\n"));
      CLR_FLAG(&adslLineAlarmConfProStruct.flags, ATUC_THRESH_15MIN_LOSS_FLAG);
      return SNMP_ERR_COMMITFAILED;
    }
    else {
      CLR_FLAG(&adslLineAlarmConfProStruct.flags, ATUC_THRESH_15MIN_LOSS_FLAG);
      return SNMP_ERR_NOERROR;
    }


}

/** XXX: return a data pointer to the data for the adslAtucThresh15MinESs column
     and set ret_len to its proper size in bytes. */
int           *
get_adslAtucThresh15MinESs(void *data_context, size_t * ret_len)
{
    struct adslLineAlarmConfProfileEntry adslLineAlarmConfProStruct;
    memset(&adslLineAlarmConfProStruct,0,sizeof(adslLineAlarmConfProfileEntry));
    strcpy(adslLineAlarmConfProStruct.adslLineAlarmConfProfileName,
        (char *)data_context);
    SET_FLAG(&adslLineAlarmConfProStruct.flags, ATUC_THRESH_15MIN_ESS_FLAG);

#ifdef ENABLE_DRIVER_CALL
    adsl_ioctl(Fd, GET_ADSL_ALRM_CONF_PROF,(void *) &adslLineAlarmConfProStruct);
#else
    adslLineAlarmConfProfileTable(Fd, GET_ADSL_ALRM_CONF_PROF,
        (void *) &adslLineAlarmConfProStruct);
#endif
    if (IS_FLAG_SET(&adslLineAlarmConfProStruct.flags,
        ATUC_THRESH_15MIN_ESS_FLAG) == 0) 
      DEBUGMSGTL(("adslMIB-Line", "GET- AtucThresh15MinESS CMV fail\n"));

    CLR_FLAG(&adslLineAlarmConfProStruct.flags, ATUC_THRESH_15MIN_ESS_FLAG);
    long_ret = adslLineAlarmConfProStruct.adslAtucThresh15MinESs;
    *ret_len = sizeof(adslLineAlarmConfProStruct.adslAtucThresh15MinESs);
    return (int *) &long_ret;
}

/** XXX: Set the value of the adslAtucThresh15MinESs column and return
         SNMPERR_SUCCESS on success
         SNMPERR_XXX     for SNMP deterministic error codes
         SNMPERR_GENERR  on generic failures (a last result response). */
int
set_adslAtucThresh15MinESs(void *data_context, long *val, size_t val_len)
{
    struct adslLineAlarmConfProfileEntry adslLineAlarmConfProStruct;
    memset(&adslLineAlarmConfProStruct,0,sizeof(adslLineAlarmConfProfileEntry));
    strcpy(adslLineAlarmConfProStruct.adslLineAlarmConfProfileName,
        (char *)data_context);
    adslLineAlarmConfProStruct.adslAtucThresh15MinESs=*val;
    SET_FLAG(&adslLineAlarmConfProStruct.flags, ATUC_THRESH_15MIN_ESS_FLAG);

#ifdef ENABLE_DRIVER_CALL
    adsl_ioctl(Fd, SET_ADSL_ALRM_CONF_PROF,(void *) &adslLineAlarmConfProStruct);
#else
    adslLineAlarmConfProfileTable(Fd, SET_ADSL_ALRM_CONF_PROF,
        (void *) &adslLineAlarmConfProStruct);
#endif
    if (IS_FLAG_SET(&adslLineAlarmConfProStruct.flags,
            ATUC_THRESH_15MIN_ESS_FLAG) == 0) {
      DEBUGMSGTL(("adslMIB-Line", "SET- AtucThresh15MinESS CMV fail\n"));
      CLR_FLAG(&adslLineAlarmConfProStruct.flags, ATUC_THRESH_15MIN_ESS_FLAG);
      return SNMP_ERR_COMMITFAILED;
    }
    else {
        CLR_FLAG(&adslLineAlarmConfProStruct.flags, ATUC_THRESH_15MIN_ESS_FLAG);
        return SNMP_ERR_NOERROR;
    }
}

/** XXX: return a data pointer to the data for the adslAtucThreshFastRateUp
    column and set ret_len to its proper size in bytes. */
u_int32         *
get_adslAtucThreshFastRateUp(void *data_context, size_t * ret_len)
{
    struct adslLineAlarmConfProfileEntry adslLineAlarmConfProStruct;
    memset(&adslLineAlarmConfProStruct,0,sizeof(adslLineAlarmConfProfileEntry));
    strcpy(adslLineAlarmConfProStruct.adslLineAlarmConfProfileName,
        (char *)data_context);
    SET_FLAG(&adslLineAlarmConfProStruct.flags, ATUC_THRESH_FAST_RATEUP_FLAG);

#ifdef ENABLE_DRIVER_CALL
    adsl_ioctl(Fd, GET_ADSL_ALRM_CONF_PROF,(void *) &adslLineAlarmConfProStruct);
#else
    adslLineAlarmConfProfileTable(Fd, GET_ADSL_ALRM_CONF_PROF,
        (void *) &adslLineAlarmConfProStruct);
#endif
    if (IS_FLAG_SET(&adslLineAlarmConfProStruct.flags,
        ATUC_THRESH_FAST_RATEUP_FLAG) == 0) 
      DEBUGMSGTL(("adslMIB-Line", "GET- AtucThreshRateUp CMV fail\n"));

    CLR_FLAG(&adslLineAlarmConfProStruct.flags, ATUC_THRESH_FAST_RATEUP_FLAG);
    long_ret = adslLineAlarmConfProStruct.adslAtucThreshFastRateUp;
    *ret_len = sizeof(adslLineAlarmConfProStruct.adslAtucThreshFastRateUp);
    return (u_int32 *) &long_ret;
}

/** XXX: Set the value of the adslAtucThreshFastRateUp column and return
         SNMPERR_SUCCESS on success
         SNMPERR_XXX     for SNMP deterministic error codes
         SNMPERR_GENERR  on generic failures (a last result response). */
int
set_adslAtucThreshFastRateUp(void *data_context, u_long * val,
                             size_t val_len)
{
    struct adslLineAlarmConfProfileEntry adslLineAlarmConfProStruct;
    memset(&adslLineAlarmConfProStruct,0,sizeof(adslLineAlarmConfProfileEntry));
    strcpy(adslLineAlarmConfProStruct.adslLineAlarmConfProfileName,
        (char *)data_context);
    adslLineAlarmConfProStruct.adslAtucThreshFastRateUp=*val;
    SET_FLAG(&adslLineAlarmConfProStruct.flags, ATUC_THRESH_FAST_RATEUP_FLAG);

#ifdef ENABLE_DRIVER_CALL
    adsl_ioctl(Fd, SET_ADSL_ALRM_CONF_PROF,(void *) &adslLineAlarmConfProStruct);
#else
    adslLineAlarmConfProfileTable(Fd, SET_ADSL_ALRM_CONF_PROF,
        (void *) &adslLineAlarmConfProStruct);
#endif
    if (IS_FLAG_SET(&adslLineAlarmConfProStruct.flags,
    	ATUC_THRESH_FAST_RATEUP_FLAG) == 0) {
     DEBUGMSGTL(("adslMIB-Line", "SET- AtucThreshRateUp CMV fail\n"));
     CLR_FLAG(&adslLineAlarmConfProStruct.flags, ATUC_THRESH_FAST_RATEUP_FLAG);
     return SNMP_ERR_COMMITFAILED;
    }
    else {
       CLR_FLAG(&adslLineAlarmConfProStruct.flags, ATUC_THRESH_FAST_RATEUP_FLAG);
       return SNMP_ERR_NOERROR;
    }
}

/** XXX: return a data pointer to the data for the
    adslAtucThreshInterleaveRateUp column and set
         ret_len to its proper size in bytes. */
u_int32         *
get_adslAtucThreshInterleaveRateUp(void *data_context, size_t * ret_len)
{
    struct adslLineAlarmConfProfileEntry adslLineAlarmConfProStruct;
    memset(&adslLineAlarmConfProStruct,0,sizeof(adslLineAlarmConfProfileEntry));
    strcpy(adslLineAlarmConfProStruct.adslLineAlarmConfProfileName,
        (char *)data_context);
    SET_FLAG(&adslLineAlarmConfProStruct.flags,
    	ATUC_THRESH_INTERLEAVE_RATEUP_FLAG);

#ifdef ENABLE_DRIVER_CALL
    adsl_ioctl(Fd, GET_ADSL_ALRM_CONF_PROF,(void *) &adslLineAlarmConfProStruct);
#else
    adslLineAlarmConfProfileTable(Fd, GET_ADSL_ALRM_CONF_PROF,
        (void *) &adslLineAlarmConfProStruct);
#endif
    if (IS_FLAG_SET(&adslLineAlarmConfProStruct.flags,
    	ATUC_THRESH_INTERLEAVE_RATEUP_FLAG) == 0) 
     DEBUGMSGTL(("adslMIB-Line", "GET- AtucThreshIntlvRateUp CMV fail\n"));

    CLR_FLAG(&adslLineAlarmConfProStruct.flags,
    ATUC_THRESH_INTERLEAVE_RATEUP_FLAG);
    long_ret = adslLineAlarmConfProStruct.adslAtucThreshInterleaveRateUp;
   *ret_len = sizeof(adslLineAlarmConfProStruct.adslAtucThreshInterleaveRateUp);
    return (u_int32 *) &long_ret;
}

/** XXX: Set the value of the adslAtucThreshInterleaveRateUp column and return
         SNMPERR_SUCCESS on success
         SNMPERR_XXX     for SNMP deterministic error codes
         SNMPERR_GENERR  on generic failures (a last result response). */
int
set_adslAtucThreshInterleaveRateUp(void *data_context, u_long * val,
                                   size_t val_len)
{
    struct adslLineAlarmConfProfileEntry adslLineAlarmConfProStruct;
    memset(&adslLineAlarmConfProStruct,0,sizeof(adslLineAlarmConfProfileEntry));
    strcpy(adslLineAlarmConfProStruct.adslLineAlarmConfProfileName,
        (char *)data_context);
    adslLineAlarmConfProStruct.adslAtucThreshInterleaveRateUp=*val;
    SET_FLAG(&adslLineAlarmConfProStruct.flags,
    ATUC_THRESH_INTERLEAVE_RATEUP_FLAG);

#ifdef ENABLE_DRIVER_CALL
    adsl_ioctl(Fd, SET_ADSL_ALRM_CONF_PROF,(void *) &adslLineAlarmConfProStruct);
#else
    adslLineAlarmConfProfileTable(Fd, SET_ADSL_ALRM_CONF_PROF,
        (void *) &adslLineAlarmConfProStruct);
#endif
    if (IS_FLAG_SET(&adslLineAlarmConfProStruct.flags,
    		ATUC_THRESH_INTERLEAVE_RATEUP_FLAG) == 0) {
     	DEBUGMSGTL(("adslMIB-Line", "SET- AtucThreshIntlvRateUp CMV fail\n"));
        CLR_FLAG(&adslLineAlarmConfProStruct.flags,
        ATUC_THRESH_INTERLEAVE_RATEUP_FLAG);
    	return SNMP_ERR_COMMITFAILED;
    }
    else {
        CLR_FLAG(&adslLineAlarmConfProStruct.flags,
        ATUC_THRESH_INTERLEAVE_RATEUP_FLAG);
    	return SNMP_ERR_NOERROR;
    }
}

/** XXX: return a data pointer to the data for the adslAtucThreshFastRateDown
    column and set ret_len to its proper size in bytes. */
u_int32         *
get_adslAtucThreshFastRateDown(void *data_context, size_t * ret_len)
{
    struct adslLineAlarmConfProfileEntry adslLineAlarmConfProStruct;
    memset(&adslLineAlarmConfProStruct,0,sizeof(adslLineAlarmConfProfileEntry));
    strcpy(adslLineAlarmConfProStruct.adslLineAlarmConfProfileName,
        (char *)data_context);
    SET_FLAG(&adslLineAlarmConfProStruct.flags, ATUC_THRESH_FAST_RATEDOWN_FLAG);

#ifdef ENABLE_DRIVER_CALL
    adsl_ioctl(Fd, GET_ADSL_ALRM_CONF_PROF,(void *) &adslLineAlarmConfProStruct);
#else
    adslLineAlarmConfProfileTable(Fd, GET_ADSL_ALRM_CONF_PROF,
        (void *) &adslLineAlarmConfProStruct);
#endif
    if (IS_FLAG_SET(&adslLineAlarmConfProStruct.flags,
    	ATUC_THRESH_FAST_RATEDOWN_FLAG) == 0) 
       DEBUGMSGTL(("adslMIB-Line", "GET- AtucThreshRateDown CMV fail\n"));

    CLR_FLAG(&adslLineAlarmConfProStruct.flags, ATUC_THRESH_FAST_RATEDOWN_FLAG);
    long_ret = adslLineAlarmConfProStruct.adslAtucThreshFastRateDown;
    *ret_len = sizeof(adslLineAlarmConfProStruct.adslAtucThreshFastRateDown);
    return (u_int32 *) &long_ret;
}

/** XXX: Set the value of the adslAtucThreshFastRateDown column and return
         SNMPERR_SUCCESS on success
         SNMPERR_XXX     for SNMP deterministic error codes
         SNMPERR_GENERR  on generic failures (a last result response). */
int
set_adslAtucThreshFastRateDown(void *data_context, u_long * val,
                               size_t val_len)
{
    struct adslLineAlarmConfProfileEntry adslLineAlarmConfProStruct;
    memset(&adslLineAlarmConfProStruct,0,sizeof(adslLineAlarmConfProfileEntry));
    strcpy(adslLineAlarmConfProStruct.adslLineAlarmConfProfileName,
        (char *)data_context);
    adslLineAlarmConfProStruct.adslAtucThreshFastRateDown=*val;
    SET_FLAG(&adslLineAlarmConfProStruct.flags, ATUC_THRESH_FAST_RATEDOWN_FLAG);

#ifdef ENABLE_DRIVER_CALL
    adsl_ioctl(Fd, SET_ADSL_ALRM_CONF_PROF,(void *) &adslLineAlarmConfProStruct);
#else
    adslLineAlarmConfProfileTable(Fd, SET_ADSL_ALRM_CONF_PROF,
        (void *) &adslLineAlarmConfProStruct);
#endif
    if (IS_FLAG_SET(&adslLineAlarmConfProStruct.flags,
    		ATUC_THRESH_FAST_RATEDOWN_FLAG) == 0)  {
       DEBUGMSGTL(("adslMIB-Line", "SET- AtucThreshRateDown CMV fail\n"));
       CLR_FLAG(&adslLineAlarmConfProStruct.flags,
             ATUC_THRESH_FAST_RATEDOWN_FLAG);
       return SNMP_ERR_COMMITFAILED;
    } 
    else {
          CLR_FLAG(&adslLineAlarmConfProStruct.flags,
              ATUC_THRESH_FAST_RATEDOWN_FLAG);
          return SNMP_ERR_NOERROR;
     }
}

/** XXX: return a data pointer to the data for the
    adslAtucThreshInterleaveRateDown column and set
         ret_len to its proper size in bytes. */
u_int32         *
get_adslAtucThreshInterleaveRateDown(void *data_context, size_t * ret_len)
{
    struct adslLineAlarmConfProfileEntry adslLineAlarmConfProStruct;
    memset(&adslLineAlarmConfProStruct,0,sizeof(adslLineAlarmConfProfileEntry));
    strcpy(adslLineAlarmConfProStruct.adslLineAlarmConfProfileName,
        (char *)data_context);
    SET_FLAG(&adslLineAlarmConfProStruct.flags,
            ATUC_THRESH_INTERLEAVE_RATEDOWN_FLAG);

#ifdef ENABLE_DRIVER_CALL
    adsl_ioctl(Fd, GET_ADSL_ALRM_CONF_PROF,(void *) &adslLineAlarmConfProStruct);
#else
    adslLineAlarmConfProfileTable(Fd, GET_ADSL_ALRM_CONF_PROF,
        (void *) &adslLineAlarmConfProStruct);
#endif
    if (IS_FLAG_SET(&adslLineAlarmConfProStruct.flags,
            ATUC_THRESH_INTERLEAVE_RATEDOWN_FLAG) == 0) 
     DEBUGMSGTL(("adslMIB-Line", "GET- AtucThreshIntlvRateDown CMV fail\n"));

    CLR_FLAG(&adslLineAlarmConfProStruct.flags,
            ATUC_THRESH_INTERLEAVE_RATEDOWN_FLAG);
    long_ret = adslLineAlarmConfProStruct.adslAtucThreshInterleaveRateDown;
    *ret_len = sizeof(adslLineAlarmConfProStruct.
                    adslAtucThreshInterleaveRateDown);
    return (u_int32 *) &long_ret;
}

/** XXX: Set the value of the adslAtucThreshInterleaveRateDown column and return
         SNMPERR_SUCCESS on success
         SNMPERR_XXX     for SNMP deterministic error codes
         SNMPERR_GENERR  on generic failures (a last result response). */
int
set_adslAtucThreshInterleaveRateDown(void *data_context, u_long * val,
                                     size_t val_len)
{
    struct adslLineAlarmConfProfileEntry adslLineAlarmConfProStruct;
    memset(&adslLineAlarmConfProStruct,0,sizeof(adslLineAlarmConfProfileEntry));
    strcpy(adslLineAlarmConfProStruct.adslLineAlarmConfProfileName,
        (char *)data_context);
    adslLineAlarmConfProStruct.adslAtucThreshInterleaveRateDown=*val;
    SET_FLAG(&adslLineAlarmConfProStruct.flags,
        ATUC_THRESH_INTERLEAVE_RATEDOWN_FLAG);

#ifdef ENABLE_DRIVER_CALL
    adsl_ioctl(Fd, SET_ADSL_ALRM_CONF_PROF,(void *) &adslLineAlarmConfProStruct);
#else
    adslLineAlarmConfProfileTable(Fd, SET_ADSL_ALRM_CONF_PROF,
        (void *) &adslLineAlarmConfProStruct);
#endif
    if (IS_FLAG_SET(&adslLineAlarmConfProStruct.flags,
        ATUC_THRESH_INTERLEAVE_RATEDOWN_FLAG) == 0) {
     	DEBUGMSGTL(("adslMIB-Line", "SET- AtucThreshIntlvRateDown CMV fail\n"));
        CLR_FLAG(&adslLineAlarmConfProStruct.flags,
            ATUC_THRESH_INTERLEAVE_RATEDOWN_FLAG);
        return SNMP_ERR_COMMITFAILED;
    }
    else {
        CLR_FLAG(&adslLineAlarmConfProStruct.flags,
            ATUC_THRESH_INTERLEAVE_RATEDOWN_FLAG);
        return SNMP_ERR_NOERROR;
    }
}

/** XXX: return a data pointer to the data for the adslAtucInitFailureTrapEnable
    column and set ret_len to its proper size in bytes. */
int           *
get_adslAtucInitFailureTrapEnable(void *data_context, size_t * ret_len)
{
    struct adslLineAlarmConfProfileEntry adslLineAlarmConfProStruct;
    memset(&adslLineAlarmConfProStruct,0,sizeof(adslLineAlarmConfProfileEntry));
    strcpy(adslLineAlarmConfProStruct.adslLineAlarmConfProfileName,
        (char *)data_context);
    SET_FLAG(&adslLineAlarmConfProStruct.flags,
        ATUC_INIT_FAILURE_TRAP_ENABLE_FLAG);

#ifdef ENABLE_DRIVER_CALL
    adsl_ioctl(Fd, GET_ADSL_ALRM_CONF_PROF,(void *) &adslLineAlarmConfProStruct);
#else
    adslLineAlarmConfProfileTable(Fd, GET_ADSL_ALRM_CONF_PROF,
        (void *) &adslLineAlarmConfProStruct);
#endif
    if (IS_FLAG_SET(&adslLineAlarmConfProStruct.flags,
        ATUC_INIT_FAILURE_TRAP_ENABLE_FLAG) == 0) 
     DEBUGMSGTL(("adslMIB-Line", "GET- AtucInitFailTrap CMV fail\n"));

    CLR_FLAG(&adslLineAlarmConfProStruct.flags,
        ATUC_INIT_FAILURE_TRAP_ENABLE_FLAG);
    long_ret = adslLineAlarmConfProStruct.adslAtucInitFailureTrapEnable;
    *ret_len = sizeof(adslLineAlarmConfProStruct.adslAtucInitFailureTrapEnable);
    return (int *) &long_ret;
}

/** XXX: Set the value of the adslAtucInitFailureTrapEnable column and return
         SNMPERR_SUCCESS on success
         SNMPERR_XXX     for SNMP deterministic error codes
         SNMPERR_GENERR  on generic failures (a last result response). */
int
set_adslAtucInitFailureTrapEnable(void *data_context, long *val,
                                  size_t val_len)
{
    struct adslLineAlarmConfProfileEntry adslLineAlarmConfProStruct;
    memset(&adslLineAlarmConfProStruct,0,sizeof(adslLineAlarmConfProfileEntry));
    strcpy(adslLineAlarmConfProStruct.adslLineAlarmConfProfileName,
        (char *)data_context);
    adslLineAlarmConfProStruct.adslAtucInitFailureTrapEnable=*val;
    SET_FLAG(&adslLineAlarmConfProStruct.flags,
        ATUC_INIT_FAILURE_TRAP_ENABLE_FLAG);

#ifdef ENABLE_DRIVER_CALL
    adsl_ioctl(Fd, SET_ADSL_ALRM_CONF_PROF,(void *) &adslLineAlarmConfProStruct);
#else
    adslLineAlarmConfProfileTable(Fd, SET_ADSL_ALRM_CONF_PROF,
        (void *) &adslLineAlarmConfProStruct);
#endif
    if (IS_FLAG_SET(&adslLineAlarmConfProStruct.flags,
            ATUC_INIT_FAILURE_TRAP_ENABLE_FLAG) == 0) {
        DEBUGMSGTL(("adslMIB-Line", "SET- AtucInitFailTrap CMV fail\n"));
        CLR_FLAG(&adslLineAlarmConfProStruct.flags,
            ATUC_INIT_FAILURE_TRAP_ENABLE_FLAG);
        return SNMP_ERR_COMMITFAILED;
    }
    else {
        CLR_FLAG(&adslLineAlarmConfProStruct.flags,
            ATUC_INIT_FAILURE_TRAP_ENABLE_FLAG);
        return SNMP_ERR_NOERROR;
    }
}

/** XXX: return a data pointer to the data for the adslAturThresh15MinLofs
    column and set ret_len to its proper size in bytes. */
int           *
get_adslAturThresh15MinLofs(void *data_context, size_t * ret_len)
{
    struct adslLineAlarmConfProfileEntry adslLineAlarmConfProStruct;
    memset(&adslLineAlarmConfProStruct,0,sizeof(adslLineAlarmConfProfileEntry));
    strcpy(adslLineAlarmConfProStruct.adslLineAlarmConfProfileName,
        (char *)data_context);
    SET_FLAG(&adslLineAlarmConfProStruct.flags, ATUR_THRESH_15MIN_LOFS_FLAG);

#ifdef ENABLE_DRIVER_CALL
    adsl_ioctl(Fd, GET_ADSL_ALRM_CONF_PROF,(void *) &adslLineAlarmConfProStruct);
#else
    adslLineAlarmConfProfileTable(Fd, GET_ADSL_ALRM_CONF_PROF,
        (void *) &adslLineAlarmConfProStruct);
#endif
    if (IS_FLAG_SET(&adslLineAlarmConfProStruct.flags,
        ATUR_THRESH_15MIN_LOFS_FLAG) == 0) 
       DEBUGMSGTL(("adslMIB-Line", "GET- AturThresh15MinLOF CMV fail\n"));

    CLR_FLAG(&adslLineAlarmConfProStruct.flags, ATUR_THRESH_15MIN_LOFS_FLAG);
    long_ret = adslLineAlarmConfProStruct.adslAturThresh15MinLofs;
    *ret_len = sizeof(adslLineAlarmConfProStruct.adslAturThresh15MinLofs);
    return (int *) &long_ret;
}

/** XXX: Set the value of the adslAturThresh15MinLofs column and return
         SNMPERR_SUCCESS on success
         SNMPERR_XXX     for SNMP deterministic error codes
         SNMPERR_GENERR  on generic failures (a last result response). */
int
set_adslAturThresh15MinLofs(void *data_context, long *val, size_t val_len)
{
    struct adslLineAlarmConfProfileEntry adslLineAlarmConfProStruct;
    memset(&adslLineAlarmConfProStruct,0,sizeof(adslLineAlarmConfProfileEntry));
    strcpy(adslLineAlarmConfProStruct.adslLineAlarmConfProfileName,
        (char *)data_context);
    adslLineAlarmConfProStruct.adslAturThresh15MinLofs=*val;
    SET_FLAG(&adslLineAlarmConfProStruct.flags, ATUR_THRESH_15MIN_LOFS_FLAG);

#ifdef ENABLE_DRIVER_CALL
    adsl_ioctl(Fd, SET_ADSL_ALRM_CONF_PROF,(void *) &adslLineAlarmConfProStruct);
#else
    adslLineAlarmConfProfileTable(Fd, SET_ADSL_ALRM_CONF_PROF,
        (void *) &adslLineAlarmConfProStruct);
#endif
    if (IS_FLAG_SET(&adslLineAlarmConfProStruct.flags,
        	ATUR_THRESH_15MIN_LOFS_FLAG) == 0) {
       DEBUGMSGTL(("adslMIB-Line", "SET- AturThresh15MinLOF CMV fail\n"));
       CLR_FLAG(&adslLineAlarmConfProStruct.flags, ATUR_THRESH_15MIN_LOFS_FLAG);
       return SNMP_ERR_COMMITFAILED;
    }
    else {
     	CLR_FLAG(&adslLineAlarmConfProStruct.flags, ATUR_THRESH_15MIN_LOFS_FLAG);
        return SNMP_ERR_NOERROR;
    }
}

/** XXX: return a data pointer to the data for the adslAturThresh15MinLoss
    column and set ret_len to its proper size in bytes. */
int           *
get_adslAturThresh15MinLoss(void *data_context, size_t * ret_len)
{
    struct adslLineAlarmConfProfileEntry adslLineAlarmConfProStruct;
    memset(&adslLineAlarmConfProStruct,0,sizeof(adslLineAlarmConfProfileEntry));
    strcpy(adslLineAlarmConfProStruct.adslLineAlarmConfProfileName,
        (char *)data_context);
    SET_FLAG(&adslLineAlarmConfProStruct.flags, ATUR_THRESH_15MIN_LOSS_FLAG);

#ifdef ENABLE_DRIVER_CALL
    adsl_ioctl(Fd, GET_ADSL_ALRM_CONF_PROF,(void *) &adslLineAlarmConfProStruct);
#else
    adslLineAlarmConfProfileTable(Fd, GET_ADSL_ALRM_CONF_PROF,
        (void *) &adslLineAlarmConfProStruct);
#endif
    if (IS_FLAG_SET(&adslLineAlarmConfProStruct.flags,
        ATUR_THRESH_15MIN_LOSS_FLAG) == 0) 
      DEBUGMSGTL(("adslMIB-Line", "GET- AturThresh15MinLOSS CMV fail\n"));

    CLR_FLAG(&adslLineAlarmConfProStruct.flags, ATUR_THRESH_15MIN_LOSS_FLAG);
    long_ret = adslLineAlarmConfProStruct.adslAturThresh15MinLoss;
    *ret_len = sizeof(adslLineAlarmConfProStruct.adslAturThresh15MinLoss);
    return (int *) &long_ret;

}

/** XXX: Set the value of the adslAturThresh15MinLoss column and return
         SNMPERR_SUCCESS on success
         SNMPERR_XXX     for SNMP deterministic error codes
         SNMPERR_GENERR  on generic failures (a last result response). */
int
set_adslAturThresh15MinLoss(void *data_context, long *val, size_t val_len)
{
    struct adslLineAlarmConfProfileEntry adslLineAlarmConfProStruct;
    memset(&adslLineAlarmConfProStruct,0,sizeof(adslLineAlarmConfProfileEntry));
    strcpy(adslLineAlarmConfProStruct.adslLineAlarmConfProfileName,
        (char *)data_context);
    adslLineAlarmConfProStruct.adslAturThresh15MinLoss=*val;
    SET_FLAG(&adslLineAlarmConfProStruct.flags, ATUR_THRESH_15MIN_LOSS_FLAG);

#ifdef ENABLE_DRIVER_CALL
    adsl_ioctl(Fd, SET_ADSL_ALRM_CONF_PROF,(void *) &adslLineAlarmConfProStruct);
#else
    adslLineAlarmConfProfileTable(Fd, SET_ADSL_ALRM_CONF_PROF,
        (void *) &adslLineAlarmConfProStruct);
#endif
    if (IS_FLAG_SET(&adslLineAlarmConfProStruct.flags,
        	ATUR_THRESH_15MIN_LOSS_FLAG) == 0) {
      	DEBUGMSGTL(("adslMIB-Line", "SET- AturThresh15MinLOSS CMV fail\n"));
     	CLR_FLAG(&adslLineAlarmConfProStruct.flags, ATUR_THRESH_15MIN_LOSS_FLAG);
        return SNMP_ERR_COMMITFAILED;
    }
    else {
     	CLR_FLAG(&adslLineAlarmConfProStruct.flags, ATUR_THRESH_15MIN_LOSS_FLAG);
        return SNMP_ERR_NOERROR;
    }
}

/** XXX: return a data pointer to the data for the adslAturThresh15MinLprs
    column and set ret_len to its proper size in bytes. */
int           *
get_adslAturThresh15MinLprs(void *data_context, size_t * ret_len)
{
    struct adslLineAlarmConfProfileEntry adslLineAlarmConfProStruct;
    memset(&adslLineAlarmConfProStruct,0,sizeof(adslLineAlarmConfProfileEntry));
    strcpy(adslLineAlarmConfProStruct.adslLineAlarmConfProfileName,
            (char *)data_context);
    SET_FLAG(&adslLineAlarmConfProStruct.flags, ATUR_THRESH_15MIN_LPRS_FLAG);

#ifdef ENABLE_DRIVER_CALL
    adsl_ioctl(Fd, GET_ADSL_ALRM_CONF_PROF,(void *) &adslLineAlarmConfProStruct);
#else
    adslLineAlarmConfProfileTable(Fd, GET_ADSL_ALRM_CONF_PROF,
        (void *) &adslLineAlarmConfProStruct);
#endif
    if (IS_FLAG_SET(&adslLineAlarmConfProStruct.flags,
        ATUR_THRESH_15MIN_LPRS_FLAG) == 0) 
      DEBUGMSGTL(("adslMIB-Line", "GET- AturThresh15MinLPR CMV fail\n"));

    CLR_FLAG(&adslLineAlarmConfProStruct.flags, ATUR_THRESH_15MIN_LPRS_FLAG);
    long_ret = adslLineAlarmConfProStruct.adslAturThresh15MinLprs;
    *ret_len = sizeof(adslLineAlarmConfProStruct.adslAturThresh15MinLprs);
    return (int *) &long_ret;
}

/** XXX: Set the value of the adslAturThresh15MinLprs column and return
         SNMPERR_SUCCESS on success
         SNMPERR_XXX     for SNMP deterministic error codes
         SNMPERR_GENERR  on generic failures (a last result response). */
int
set_adslAturThresh15MinLprs(void *data_context, long *val, size_t val_len)
{
    struct adslLineAlarmConfProfileEntry adslLineAlarmConfProStruct;
    memset(&adslLineAlarmConfProStruct,0,sizeof(adslLineAlarmConfProfileEntry));
    strcpy(adslLineAlarmConfProStruct.adslLineAlarmConfProfileName,
        (char *)data_context);
    adslLineAlarmConfProStruct.adslAturThresh15MinLprs=*val;
    SET_FLAG(&adslLineAlarmConfProStruct.flags, ATUR_THRESH_15MIN_LPRS_FLAG);

#ifdef ENABLE_DRIVER_CALL
    adsl_ioctl(Fd, SET_ADSL_ALRM_CONF_PROF,(void *) &adslLineAlarmConfProStruct);
#else
    adslLineAlarmConfProfileTable(Fd, SET_ADSL_ALRM_CONF_PROF,
        (void *) &adslLineAlarmConfProStruct);
#endif
    if (IS_FLAG_SET(&adslLineAlarmConfProStruct.flags,
        	ATUR_THRESH_15MIN_LPRS_FLAG) == 0) {
      	DEBUGMSGTL(("adslMIB-Line", "SET- AturThresh15MinLPR CMV fail\n"));
     	CLR_FLAG(&adslLineAlarmConfProStruct.flags, ATUR_THRESH_15MIN_LPRS_FLAG);
        return SNMP_ERR_COMMITFAILED;
    }
    else {
      	CLR_FLAG(&adslLineAlarmConfProStruct.flags, ATUR_THRESH_15MIN_LPRS_FLAG);
        return SNMP_ERR_NOERROR;
    }
}

/** XXX: return a data pointer to the data for the adslAturThresh15MinESs column
    and set ret_len to its proper size in bytes. */
int           *
get_adslAturThresh15MinESs(void *data_context, size_t * ret_len)
{
    struct adslLineAlarmConfProfileEntry adslLineAlarmConfProStruct;
    memset(&adslLineAlarmConfProStruct,0,sizeof(adslLineAlarmConfProfileEntry));
    strcpy(adslLineAlarmConfProStruct.adslLineAlarmConfProfileName,
        (char *)data_context);
    SET_FLAG(&adslLineAlarmConfProStruct.flags, ATUR_THRESH_15MIN_ESS_FLAG);

#ifdef ENABLE_DRIVER_CALL
    adsl_ioctl(Fd, GET_ADSL_ALRM_CONF_PROF,(void *) &adslLineAlarmConfProStruct);
#else
    adslLineAlarmConfProfileTable(Fd, GET_ADSL_ALRM_CONF_PROF,
        (void *) &adslLineAlarmConfProStruct);
#endif
    if (IS_FLAG_SET(&adslLineAlarmConfProStruct.flags,
        ATUR_THRESH_15MIN_ESS_FLAG) == 0) 
      DEBUGMSGTL(("adslMIB-Line", "GET- AturThresh15MinESS CMV fail\n"));

    CLR_FLAG(&adslLineAlarmConfProStruct.flags, ATUR_THRESH_15MIN_ESS_FLAG);
    long_ret = adslLineAlarmConfProStruct.adslAturThresh15MinESs;
    *ret_len = sizeof(adslLineAlarmConfProStruct.adslAturThresh15MinESs);
    return (int *) &long_ret;
}

/** XXX: Set the value of the adslAturThresh15MinESs column and return
         SNMPERR_SUCCESS on success
         SNMPERR_XXX     for SNMP deterministic error codes
         SNMPERR_GENERR  on generic failures (a last result response). */
int
set_adslAturThresh15MinESs(void *data_context, long *val, size_t val_len)
{
    struct adslLineAlarmConfProfileEntry adslLineAlarmConfProStruct;
    memset(&adslLineAlarmConfProStruct,0,sizeof(adslLineAlarmConfProfileEntry));
    strcpy(adslLineAlarmConfProStruct.adslLineAlarmConfProfileName,
        (char *)data_context);
    adslLineAlarmConfProStruct.adslAturThresh15MinESs=*val;
    SET_FLAG(&adslLineAlarmConfProStruct.flags, ATUR_THRESH_15MIN_ESS_FLAG);

#ifdef ENABLE_DRIVER_CALL
    adsl_ioctl(Fd, SET_ADSL_ALRM_CONF_PROF,(void *) &adslLineAlarmConfProStruct);
#else
    adslLineAlarmConfProfileTable(Fd, SET_ADSL_ALRM_CONF_PROF,
        (void *) &adslLineAlarmConfProStruct);
#endif
    if (IS_FLAG_SET(&adslLineAlarmConfProStruct.flags,
        	ATUR_THRESH_15MIN_ESS_FLAG) == 0) {
      	DEBUGMSGTL(("adslMIB-Line", "SET- AturThresh15MinESS CMV fail\n"));
     	CLR_FLAG(&adslLineAlarmConfProStruct.flags, ATUR_THRESH_15MIN_ESS_FLAG);
        return SNMP_ERR_COMMITFAILED;
    }
    else {
        CLR_FLAG(&adslLineAlarmConfProStruct.flags, ATUR_THRESH_15MIN_ESS_FLAG);
        return SNMP_ERR_NOERROR;
    }
}

/** XXX: return a data pointer to the data for the adslAturThreshFastRateUp
    column and set ret_len to its proper size in bytes. */
u_int32         *
get_adslAturThreshFastRateUp(void *data_context, size_t * ret_len)
{
    struct adslLineAlarmConfProfileEntry adslLineAlarmConfProStruct;
    memset(&adslLineAlarmConfProStruct,0,sizeof(adslLineAlarmConfProfileEntry));
    strcpy(adslLineAlarmConfProStruct.adslLineAlarmConfProfileName,
        (char *)data_context);
    SET_FLAG(&adslLineAlarmConfProStruct.flags, ATUR_THRESH_FAST_RATEUP_FLAG);

#ifdef ENABLE_DRIVER_CALL
    adsl_ioctl(Fd, GET_ADSL_ALRM_CONF_PROF,(void *) &adslLineAlarmConfProStruct);
#else
    adslLineAlarmConfProfileTable(Fd, GET_ADSL_ALRM_CONF_PROF,
        (void *) &adslLineAlarmConfProStruct);
#endif
    if (IS_FLAG_SET(&adslLineAlarmConfProStruct.flags,
        ATUR_THRESH_FAST_RATEUP_FLAG) == 0) 
      DEBUGMSGTL(("adslMIB-Line", "GET- AturThreshRateUp CMV fail\n"));

    CLR_FLAG(&adslLineAlarmConfProStruct.flags, ATUR_THRESH_FAST_RATEUP_FLAG);
    long_ret = adslLineAlarmConfProStruct.adslAturThreshFastRateUp;
    *ret_len = sizeof(adslLineAlarmConfProStruct.adslAturThreshFastRateUp);
    return (u_int32 *) &long_ret;
}

/** XXX: Set the value of the adslAturThreshFastRateUp column and return
         SNMPERR_SUCCESS on success
         SNMPERR_XXX     for SNMP deterministic error codes
         SNMPERR_GENERR  on generic failures (a last result response). */
int
set_adslAturThreshFastRateUp(void *data_context, u_long * val,
                             size_t val_len)
{
    struct adslLineAlarmConfProfileEntry adslLineAlarmConfProStruct;
    memset(&adslLineAlarmConfProStruct,0,sizeof(adslLineAlarmConfProfileEntry));
    strcpy(adslLineAlarmConfProStruct.adslLineAlarmConfProfileName,
        (char *)data_context);
    adslLineAlarmConfProStruct.adslAturThreshFastRateUp=*val;
    SET_FLAG(&adslLineAlarmConfProStruct.flags, ATUR_THRESH_FAST_RATEUP_FLAG);

#ifdef ENABLE_DRIVER_CALL
    adsl_ioctl(Fd, SET_ADSL_ALRM_CONF_PROF,(void *) &adslLineAlarmConfProStruct);
#else
    adslLineAlarmConfProfileTable(Fd, SET_ADSL_ALRM_CONF_PROF,
        (void *) &adslLineAlarmConfProStruct);
#endif
    if (IS_FLAG_SET(&adslLineAlarmConfProStruct.flags,
        	ATUR_THRESH_FAST_RATEUP_FLAG) == 0) {
     	DEBUGMSGTL(("adslMIB-Line", "SET- AturThreshRateUp CMV fail\n"));
    	CLR_FLAG(&adslLineAlarmConfProStruct.flags, ATUR_THRESH_FAST_RATEUP_FLAG);
        return SNMP_ERR_COMMITFAILED;
    }
    else {
     	CLR_FLAG(&adslLineAlarmConfProStruct.flags, ATUR_THRESH_FAST_RATEUP_FLAG);
        return SNMP_ERR_NOERROR;
    }
}

/** XXX: return a data pointer to the data for the
    adslAturThreshInterleaveRateUp column and set
         ret_len to its proper size in bytes. */
u_int32         *
get_adslAturThreshInterleaveRateUp(void *data_context, size_t * ret_len)
{
    struct adslLineAlarmConfProfileEntry adslLineAlarmConfProStruct;
    memset(&adslLineAlarmConfProStruct,0,sizeof(adslLineAlarmConfProfileEntry));
    strcpy(adslLineAlarmConfProStruct.adslLineAlarmConfProfileName,
        (char *)data_context);
    SET_FLAG(&adslLineAlarmConfProStruct.flags,
        ATUR_THRESH_INTERLEAVE_RATEUP_FLAG);

#ifdef ENABLE_DRIVER_CALL
    adsl_ioctl(Fd, GET_ADSL_ALRM_CONF_PROF,(void *) &adslLineAlarmConfProStruct);
#else
    adslLineAlarmConfProfileTable(Fd, GET_ADSL_ALRM_CONF_PROF,
        (void *) &adslLineAlarmConfProStruct);
#endif
    if (IS_FLAG_SET(&adslLineAlarmConfProStruct.flags,
        ATUR_THRESH_INTERLEAVE_RATEUP_FLAG) == 0) 
     DEBUGMSGTL(("adslMIB-Line", "GET- AturThreshIntlvRateUp CMV fail\n"));

    CLR_FLAG(&adslLineAlarmConfProStruct.flags,
        ATUR_THRESH_INTERLEAVE_RATEUP_FLAG);
    long_ret = adslLineAlarmConfProStruct.adslAturThreshInterleaveRateUp;
   *ret_len = sizeof(adslLineAlarmConfProStruct.adslAturThreshInterleaveRateUp);
    return (u_int32 *) &long_ret;
}

/** XXX: Set the value of the adslAturThreshInterleaveRateUp column and return
         SNMPERR_SUCCESS on success
         SNMPERR_XXX     for SNMP deterministic error codes
         SNMPERR_GENERR  on generic failures (a last result response). */
int
set_adslAturThreshInterleaveRateUp(void *data_context, u_long * val,
                                   size_t val_len)
{
    struct adslLineAlarmConfProfileEntry adslLineAlarmConfProStruct;
    memset(&adslLineAlarmConfProStruct,0,sizeof(adslLineAlarmConfProfileEntry));
    strcpy(adslLineAlarmConfProStruct.adslLineAlarmConfProfileName,
        (char *)data_context);
    adslLineAlarmConfProStruct.adslAturThreshInterleaveRateUp=*val;
    SET_FLAG(&adslLineAlarmConfProStruct.flags,
        ATUR_THRESH_INTERLEAVE_RATEUP_FLAG);

#ifdef ENABLE_DRIVER_CALL
    adsl_ioctl(Fd, SET_ADSL_ALRM_CONF_PROF,(void *) &adslLineAlarmConfProStruct);
#else
    adslLineAlarmConfProfileTable(Fd, SET_ADSL_ALRM_CONF_PROF,
        (void *) &adslLineAlarmConfProStruct);
#endif
    if (IS_FLAG_SET(&adslLineAlarmConfProStruct.flags,
        	ATUR_THRESH_INTERLEAVE_RATEUP_FLAG) == 0) {
     	DEBUGMSGTL(("adslMIB-Line", "SET- AturThreshIntlvRateUp CMV fail\n"));
      CLR_FLAG(&adslLineAlarmConfProStruct.flags,
           ATUR_THRESH_INTERLEAVE_RATEUP_FLAG);
      return SNMP_ERR_COMMITFAILED;
    }
    else {
        CLR_FLAG(&adslLineAlarmConfProStruct.flags,
            ATUR_THRESH_INTERLEAVE_RATEUP_FLAG);
        return SNMP_ERR_NOERROR;
    }
}

/** XXX: return a data pointer to the data for the adslAturThreshFastRateDown
    column and set ret_len to its proper size in bytes. */
u_int32         *
get_adslAturThreshFastRateDown(void *data_context, size_t * ret_len)
{
    struct adslLineAlarmConfProfileEntry adslLineAlarmConfProStruct;
    memset(&adslLineAlarmConfProStruct,0,sizeof(adslLineAlarmConfProfileEntry));
    strcpy(adslLineAlarmConfProStruct.adslLineAlarmConfProfileName,
        (char *)data_context);
    SET_FLAG(&adslLineAlarmConfProStruct.flags, ATUR_THRESH_FAST_RATEDOWN_FLAG);

#ifdef ENABLE_DRIVER_CALL
    adsl_ioctl(Fd, GET_ADSL_ALRM_CONF_PROF,(void *) &adslLineAlarmConfProStruct);
#else
    adslLineAlarmConfProfileTable(Fd, GET_ADSL_ALRM_CONF_PROF,
        (void *) &adslLineAlarmConfProStruct);
#endif
    if (IS_FLAG_SET(&adslLineAlarmConfProStruct.flags,
        	ATUR_THRESH_FAST_RATEDOWN_FLAG) == 0) 
       DEBUGMSGTL(("adslMIB-Line", "GET- AturThreshRateDown CMV fail\n"));

    CLR_FLAG(&adslLineAlarmConfProStruct.flags, ATUR_THRESH_FAST_RATEDOWN_FLAG);
    long_ret = adslLineAlarmConfProStruct.adslAturThreshFastRateDown;
    *ret_len = sizeof(adslLineAlarmConfProStruct.adslAturThreshFastRateDown);
    return (u_int32 *) &long_ret;
}

/** XXX: Set the value of the adslAturThreshFastRateDown column and return
         SNMPERR_SUCCESS on success
         SNMPERR_XXX     for SNMP deterministic error codes
         SNMPERR_GENERR  on generic failures (a last result response). */
int
set_adslAturThreshFastRateDown(void *data_context, u_long * val,
                               size_t val_len)
{
    struct adslLineAlarmConfProfileEntry adslLineAlarmConfProStruct;
    memset(&adslLineAlarmConfProStruct,0,sizeof(adslLineAlarmConfProfileEntry));
    strcpy(adslLineAlarmConfProStruct.adslLineAlarmConfProfileName,
        (char *)data_context);
    adslLineAlarmConfProStruct.adslAturThreshFastRateDown=*val;
    SET_FLAG(&adslLineAlarmConfProStruct.flags, ATUR_THRESH_FAST_RATEDOWN_FLAG);

#ifdef ENABLE_DRIVER_CALL
    adsl_ioctl(Fd, SET_ADSL_ALRM_CONF_PROF,(void *) &adslLineAlarmConfProStruct);
#else
    adslLineAlarmConfProfileTable(Fd, SET_ADSL_ALRM_CONF_PROF,
        (void *) &adslLineAlarmConfProStruct);
#endif
    if (IS_FLAG_SET(&adslLineAlarmConfProStruct.flags,
        ATUR_THRESH_FAST_RATEDOWN_FLAG) == 0) {
       DEBUGMSGTL(("adslMIB-Line", "SET- AturThreshRateDown CMV fail\n"));
       CLR_FLAG(&adslLineAlarmConfProStruct.flags,
            ATUR_THRESH_FAST_RATEDOWN_FLAG);
        return SNMP_ERR_COMMITFAILED;
    }
    else {
        CLR_FLAG(&adslLineAlarmConfProStruct.flags,
            ATUR_THRESH_FAST_RATEDOWN_FLAG);
        return SNMP_ERR_NOERROR;
    }
}

/** XXX: return a data pointer to the data for the
    adslAturThreshInterleaveRateDown column and set
         ret_len to its proper size in bytes. */
u_int32         *
get_adslAturThreshInterleaveRateDown(void *data_context, size_t * ret_len)
{
    struct adslLineAlarmConfProfileEntry adslLineAlarmConfProStruct;
    memset(&adslLineAlarmConfProStruct,0,sizeof(adslLineAlarmConfProfileEntry));
    strcpy(adslLineAlarmConfProStruct.adslLineAlarmConfProfileName,
        (char *)data_context);
    SET_FLAG(&adslLineAlarmConfProStruct.flags,
        ATUR_THRESH_INTERLEAVE_RATEDOWN_FLAG);

#ifdef ENABLE_DRIVER_CALL
    adsl_ioctl(Fd, GET_ADSL_ALRM_CONF_PROF,(void *) &adslLineAlarmConfProStruct);
#else
    adslLineAlarmConfProfileTable(Fd, GET_ADSL_ALRM_CONF_PROF,
        (void *) &adslLineAlarmConfProStruct);
#endif
    if (IS_FLAG_SET(&adslLineAlarmConfProStruct.flags,
        ATUR_THRESH_INTERLEAVE_RATEDOWN_FLAG) == 0) 
     DEBUGMSGTL(("adslMIB-Line", "GET- AturThreshIntlvRateDown CMV fail\n"));

    CLR_FLAG(&adslLineAlarmConfProStruct.flags,
        ATUR_THRESH_INTERLEAVE_RATEDOWN_FLAG);
    long_ret = adslLineAlarmConfProStruct.adslAturThreshInterleaveRateDown;
    *ret_len = sizeof(adslLineAlarmConfProStruct.
                    adslAturThreshInterleaveRateDown);
    return (u_int32 *) &long_ret;
}

/** XXX: Set the value of the adslAturThreshInterleaveRateDown column and return
         SNMPERR_SUCCESS on success
         SNMPERR_XXX     for SNMP deterministic error codes
         SNMPERR_GENERR  on generic failures (a last result response). */
int
set_adslAturThreshInterleaveRateDown(void *data_context, u_long * val,
                                     size_t val_len)
{
    struct adslLineAlarmConfProfileEntry adslLineAlarmConfProStruct;
    memset(&adslLineAlarmConfProStruct,0,sizeof(adslLineAlarmConfProfileEntry));
    strcpy(adslLineAlarmConfProStruct.adslLineAlarmConfProfileName,
        (char *)data_context);
    adslLineAlarmConfProStruct.adslAturThreshInterleaveRateDown=*val;
    SET_FLAG(&adslLineAlarmConfProStruct.flags,
        ATUR_THRESH_INTERLEAVE_RATEDOWN_FLAG);

#ifdef ENABLE_DRIVER_CALL
    adsl_ioctl(Fd, SET_ADSL_ALRM_CONF_PROF,(void *) &adslLineAlarmConfProStruct);
#else
    adslLineAlarmConfProfileTable(Fd, SET_ADSL_ALRM_CONF_PROF,
        (void *) &adslLineAlarmConfProStruct);
#endif
    if (IS_FLAG_SET(&adslLineAlarmConfProStruct.flags,
        	ATUR_THRESH_INTERLEAVE_RATEDOWN_FLAG) == 0) {
     	DEBUGMSGTL(("adslMIB-Line", "SET- AturThreshIntlvRateDown CMV fail\n"));
        CLR_FLAG(&adslLineAlarmConfProStruct.flags,
            ATUR_THRESH_INTERLEAVE_RATEDOWN_FLAG);
        return SNMP_ERR_COMMITFAILED;
    }
    else {
        CLR_FLAG(&adslLineAlarmConfProStruct.flags,
            ATUR_THRESH_INTERLEAVE_RATEDOWN_FLAG);
        return SNMP_ERR_NOERROR;
    }
}

/** XXX: return a data pointer to the data for the
    adslLineAlarmConfProfileRowStatus column and set
         ret_len to its proper size in bytes. */
int           *
get_adslLineAlarmConfProfileRowStatus(void *data_context, size_t * ret_len)
{
    struct adslLineAlarmConfProfileEntry adslLineAlarmConfProStruct;
    memset(&adslLineAlarmConfProStruct,0,sizeof(adslLineAlarmConfProfileEntry));
    strcpy(adslLineAlarmConfProStruct.adslLineAlarmConfProfileName,
        (char *)data_context);
    SET_FLAG(&adslLineAlarmConfProStruct.flags,
        LINE_ALARM_CONF_PROFILE_ROWSTATUS_FLAG);

#ifdef ENABLE_DRIVER_CALL
    adsl_ioctl(Fd, GET_ADSL_ALRM_CONF_PROF,(void *) &adslLineAlarmConfProStruct);
#else
    adslLineAlarmConfProfileTable(Fd, GET_ADSL_ALRM_CONF_PROF,
        (void *) &adslLineAlarmConfProStruct);
#endif
    if (IS_FLAG_SET(&adslLineAlarmConfProStruct.flags,
        LINE_ALARM_CONF_PROFILE_ROWSTATUS_FLAG) == 0) 
     DEBUGMSGTL(("adslMIB-Line", "GET- ProfileRowStat CMV fail\n"));

    CLR_FLAG(&adslLineAlarmConfProStruct.flags,
        LINE_ALARM_CONF_PROFILE_ROWSTATUS_FLAG);
    long_ret = adslLineAlarmConfProStruct.adslLineAlarmConfProfileRowStatus;
    *ret_len = sizeof(adslLineAlarmConfProStruct.
                        adslLineAlarmConfProfileRowStatus);
    return (int *) &long_ret;
}

/** XXX: Set the value of the adslLineAlarmConfProfileRowStatus column and
    return
         SNMPERR_SUCCESS on success
         SNMPERR_XXX     for SNMP deterministic error codes
         SNMPERR_GENERR  on generic failures (a last result response). */
int
set_adslLineAlarmConfProfileRowStatus(void *data_context, long *val,
                                      size_t val_len)
{
    return SNMP_ERR_NOTWRITABLE;      /** XXX: change if an error occurs */
}
#endif /* HAVE_OPTIMIZED_CODE */


#ifndef ENABLE_DRIVER_CALL
int adslLineAlarmConfProfileTable(int Fd2, int ADSL_ALRM_CONF_PROF2,
            void *adslLineAlarmStruct)
{
    struct adslLineAlarmConfProfileEntry *adslLineAlarmValue;
    adslLineAlarmValue = (adslLineAlarmConfProfileEntry *)adslLineAlarmStruct;
    if (ADSL_ALRM_CONF_PROF2 == GET_ADSL_ALRM_CONF_PROF)
    {

    adslLineAlarmValue->adslAtucThresh15MinLofs = adslAtucTh15MinLofs;
    adslLineAlarmValue->adslAtucThresh15MinLoss = adslAtucTh15MinLoss;
    adslLineAlarmValue->adslAtucThresh15MinESs = adslAtucTh15MinESs;
    adslLineAlarmValue->adslAtucThreshFastRateUp = adslAtucThFastRateUp;
    adslLineAlarmValue->adslAtucThreshInterleaveRateUp =
    adslAtucThInterleaveRateUp;
    adslLineAlarmValue->adslAtucThreshFastRateDown = adslAtucThFastRateDown;
    adslLineAlarmValue->adslAtucThreshInterleaveRateDown =
    adslAtucThInterleaveRateDown;
    adslLineAlarmValue->adslAtucInitFailureTrapEnable =
    adslAtucInitFailTrapEnable;
    adslLineAlarmValue->adslAturThresh15MinLofs = adslAturTh15MinLofs;
    adslLineAlarmValue->adslAturThresh15MinLoss = adslAturTh15MinLoss;
    adslLineAlarmValue->adslAturThresh15MinLprs = adslAturTh15MinLprs;
    adslLineAlarmValue->adslAturThresh15MinESs = adslAturTh15MinESs;
    adslLineAlarmValue->adslAturThreshFastRateUp = adslAturThFastRateUp;
    adslLineAlarmValue->adslAturThreshInterleaveRateUp =
    adslAturThInterleaveRateUp;
    adslLineAlarmValue->adslAturThreshFastRateDown = adslAturThFastRateDown;
    adslLineAlarmValue->adslAturThreshInterleaveRateDown =
    adslAturThInterleaveRateDown;
    adslLineAlarmValue->adslLineAlarmConfProfileRowStatus =
    adslLineAlarmConfProfRowStatus;

    }
    else if (ADSL_ALRM_CONF_PROF2 == SET_ADSL_ALRM_CONF_PROF) {

   if (IS_FLAG_SET(&adslLineAlarmValue->flags,ATUC_THRESH_15MIN_LOFS_FLAG) != 0)
    adslAtucTh15MinLofs = adslLineAlarmValue->adslAtucThresh15MinLofs;

   if (IS_FLAG_SET(&adslLineAlarmValue->flags,ATUC_THRESH_15MIN_LOSS_FLAG) != 0)
    adslAtucTh15MinLoss = adslLineAlarmValue->adslAtucThresh15MinLoss;

   if (IS_FLAG_SET(&adslLineAlarmValue->flags,ATUC_THRESH_15MIN_ESS_FLAG) != 0)
   adslAtucTh15MinESs = adslLineAlarmValue->adslAtucThresh15MinESs;

  if (IS_FLAG_SET(&adslLineAlarmValue->flags,ATUC_THRESH_FAST_RATEUP_FLAG) != 0)
   adslAtucThFastRateUp  = adslLineAlarmValue->adslAtucThreshFastRateUp ;

  if (IS_FLAG_SET(&adslLineAlarmValue->flags,ATUC_THRESH_INTERLEAVE_RATEUP_FLAG)
   != 0)
   adslAtucThInterleaveRateUp = adslLineAlarmValue->
   adslAtucThreshInterleaveRateUp;

   if (IS_FLAG_SET(&adslLineAlarmValue->flags,ATUC_THRESH_FAST_RATEDOWN_FLAG) !=
    0)
   adslAtucThFastRateDown = adslLineAlarmValue->adslAtucThreshFastRateDown;

   if (IS_FLAG_SET(&adslLineAlarmValue->flags,
         ATUC_THRESH_INTERLEAVE_RATEDOWN_FLAG) != 0)
       adslAtucThInterleaveRateDown = adslLineAlarmValue->
            adslAtucThreshInterleaveRateDown;

   if (IS_FLAG_SET(&adslLineAlarmValue->flags,ATUC_INIT_FAILURE_TRAP_ENABLE_FLAG
   ) != 0)
  adslAtucInitFailTrapEnable =adslLineAlarmValue->adslAtucInitFailureTrapEnable;

   if (IS_FLAG_SET(&adslLineAlarmValue->flags,ATUR_THRESH_15MIN_LOFS_FLAG) != 0)
   adslAturTh15MinLofs= adslLineAlarmValue->adslAturThresh15MinLofs;

   if (IS_FLAG_SET(&adslLineAlarmValue->flags,ATUR_THRESH_15MIN_LOSS_FLAG) != 0)
   adslAturTh15MinLoss =adslLineAlarmValue->adslAturThresh15MinLoss;

   if (IS_FLAG_SET(&adslLineAlarmValue->flags,ATUR_THRESH_15MIN_LPRS_FLAG) != 0)
   adslAturTh15MinLprs= adslLineAlarmValue->adslAturThresh15MinLprs;

   if (IS_FLAG_SET(&adslLineAlarmValue->flags,ATUR_THRESH_15MIN_ESS_FLAG) != 0)
   adslAturTh15MinESs= adslLineAlarmValue->adslAturThresh15MinESs;

  if (IS_FLAG_SET(&adslLineAlarmValue->flags,ATUR_THRESH_FAST_RATEUP_FLAG) != 0)
   adslAturThFastRateUp =adslLineAlarmValue->adslAturThreshFastRateUp;

  if (IS_FLAG_SET(&adslLineAlarmValue->flags,ATUR_THRESH_INTERLEAVE_RATEUP_FLAG)
   != 0)
   adslAturThInterleaveRateUp =adslLineAlarmValue->
        adslAturThreshInterleaveRateUp;

   if (IS_FLAG_SET(&adslLineAlarmValue->flags,ATUR_THRESH_FAST_RATEDOWN_FLAG) !=
    0)
   adslAturThFastRateDown =adslLineAlarmValue->adslAturThreshFastRateDown;

   if (IS_FLAG_SET(&adslLineAlarmValue->flags,
            ATUR_THRESH_INTERLEAVE_RATEDOWN_FLAG) != 0)
       adslAturThInterleaveRateDown =adslLineAlarmValue->
                adslAturThreshInterleaveRateDown;
    }

    return 0;
}
#endif
