/************************************************************************
 *
 *    Copyright (c) 2005
 *    Infineon Technologies AG
 *    St. Martin Strasse 53; 81669 Muenchen; Germany
 *
 *    This document contains proprietary information belonging to Infineon
 *    Technologies AG. Passing on and copying of this document, and communication
 *    of its contents is not permitted without prior written authorisation.
 *
 *    --------------------------------------------------------------------
 *    
 *        Project : INCA-IP
 *        Block   : IFX-IIP-VOIP-MIB
 *        Creator : Sharon Tseng
 *        File    : ifxCallFwTable_access.c
 *        Abstract: 
 *                  
 *        Date    : 24-May-2005
 *        Ref. Doc: IIP-DFS.doc
 *    
 *    Modification History:
 *           By              Date     Ver.   Modification Description
 *           --------------- -------- -----  -----------------------------
 *
 ************************************************************************/

/*
 * Note: this file originally auto-generated by mib2c using
 *        : mib2c.access_functions.conf,v 1.9 2004/10/14 12:57:33 dts12 Exp $
 */

/*
 * ===========================================================================
 *                           INCLUDE FILES
 * ===========================================================================
*/
#include <net-snmp/net-snmp-config.h>
#include <net-snmp/net-snmp-includes.h>
#include <net-snmp/agent/net-snmp-agent-includes.h>
#include "ifxCallFwTable_access.h"

/*
 * ===========================================================================
 *                          GLOBAL DEFINITIONS
 * ===========================================================================
*/
static VOIPCALLFWCFG_S      stCfg[MAX_CFTYPE];
static x_IFX_CM_Msg         g_xCmMsg;

netsnmp_variable_list *
ifxCallFwTable_set_indexes(VOIPCALLFWCFG_S *datainfo,
                           netsnmp_variable_list *put_index_data)
{
    /* printf("**** ifxCallFwTable_set_indexes ****\n"); */
    netsnmp_variable_list   *vptr;

    /* endPointIdx */
    vptr = put_index_data;
    snmp_set_var_value(vptr, (u_char *) &datainfo->ulEndPointIdx,
                       sizeof(datainfo->ulEndPointIdx) );

    /* suUserName */
    vptr = vptr->next_variable;
    snmp_set_var_value(vptr, (u_char *) &datainfo->cUserName,
                       strlen(datainfo->cUserName) );

    /* suDomainName */
    vptr = vptr->next_variable;
    snmp_set_var_value(vptr, (u_char *) &datainfo->cDomainName,
                       strlen(datainfo->cDomainName) );

    /* cfType */
    vptr = vptr->next_variable;
    snmp_set_var_value(vptr, (u_char *) &datainfo->ulType ,
                       sizeof(datainfo->ulType) );

    return put_index_data;
}

void  *
ifxCallFwTable_get_data(void)
{
    int              j = 0;
    u_long           ulRetVal = 0;

    for ( j = 0; j < MAX_CFTYPE; j++)
    {
        memset (&stCfg[j], 0x00, sizeof(VOIPCALLFWCFG_S));
        memset (&g_xCmMsg, 0x00, sizeof(x_IFX_CM_Msg));

       	g_xCmMsg.ucMsgType = IFX_CM_GET_REQ;
    	g_xCmMsg.ucInfoType = IFX_CM_SIP_CFG_USER;
    	g_xCmMsg.ucChannel = 0;
    
        if (IFX_CM_RecvDataFromCM (&g_xCmMsg) != IFX_CM_SUCCESS)
        {
            snmp_log(LOG_ERR,"ifxCallFwTable: Fail to receive data from CM\n");
        }

        stCfg[j].ulEndPointIdx = g_xCmMsg.ucChannel;
        strncpy (stCfg[j].cUserName,
                 g_xCmMsg.uxData.xSipUserCfg.acUserName,
                 strlen(g_xCmMsg.uxData.xSipUserCfg.acUserName));
        strncpy (stCfg[j].cDomainName,
                 g_xCmMsg.uxData.xSipUserCfg.acDomain,
                 strlen(g_xCmMsg.uxData.xSipUserCfg.acDomain));

      	g_xCmMsg.ucMsgType = IFX_CM_GET_REQ;
    	g_xCmMsg.ucInfoType = IFX_CM_APP_CALL_CFG;
    	g_xCmMsg.ucChannel = 0;
    
        if (IFX_CM_RecvDataFromCM (&g_xCmMsg) != IFX_CM_SUCCESS)
        {
            snmp_log(LOG_ERR,"ifxCallFwTable: Fail to receive data from CM\n");
        }
    }

    j = 0;
    ulRetVal = g_xCmMsg.uxData.xCallCfg.xSipFwd.ucType;
    stCfg[j].lRowStatus = (ulRetVal & IFX_CM_FWD_UNCOND) ?
                          ROWSTATUS_ACTIVE : ROWSTATUS_NOTINSERVICE;

    stCfg[j].ulType = IFX_CM_FWD_UNCOND;
    stCfg[j].ulAddrType =
        g_xCmMsg.uxData.xCallCfg.xSipFwd.xFwdAddrUncon.ucAddrType;
    strcpy (stCfg[j].cDisplayName,
            g_xCmMsg.uxData.xCallCfg.xSipFwd.xFwdAddrUncon.acDisplayName);
    strcpy (stCfg[j].cCFUserName,
            g_xCmMsg.uxData.xCallCfg.xSipFwd.xFwdAddrUncon.acUserName);
    strcpy (stCfg[j].cCalledAddr,
            g_xCmMsg.uxData.xCallCfg.xSipFwd.xFwdAddrUncon.acCalledAddr);
    stCfg[j].ulPort =
        g_xCmMsg.uxData.xCallCfg.xSipFwd.xFwdAddrUncon.unPort;
    stCfg[j].ulAddrProto =
        g_xCmMsg.uxData.xCallCfg.xSipFwd.xFwdAddrUncon.ucAddrProto;

    j++;
    stCfg[j].lRowStatus = (ulRetVal & IFX_CM_FWD_ONBUSY) ?
                          ROWSTATUS_ACTIVE : ROWSTATUS_NOTINSERVICE;

    stCfg[j].ulType = IFX_CM_FWD_ONBUSY;
    stCfg[j].ulAddrType =
        g_xCmMsg.uxData.xCallCfg.xSipFwd.xFwdAddrBusy.ucAddrType;
    strcpy (stCfg[j].cDisplayName,
            g_xCmMsg.uxData.xCallCfg.xSipFwd.xFwdAddrBusy.acDisplayName);
    strcpy (stCfg[j].cCFUserName,
            g_xCmMsg.uxData.xCallCfg.xSipFwd.xFwdAddrBusy.acUserName);
    strcpy (stCfg[j].cCalledAddr,
            g_xCmMsg.uxData.xCallCfg.xSipFwd.xFwdAddrBusy.acCalledAddr);
    stCfg[j].ulPort =
        g_xCmMsg.uxData.xCallCfg.xSipFwd.xFwdAddrBusy.unPort;
    stCfg[j].ulAddrProto =
        g_xCmMsg.uxData.xCallCfg.xSipFwd.xFwdAddrBusy.ucAddrProto;

    j++;
    stCfg[j].lRowStatus = (ulRetVal & IFX_CM_FWD_NOANSW) ?
                          ROWSTATUS_ACTIVE : ROWSTATUS_NOTINSERVICE;

    stCfg[j].ulType = IFX_CM_FWD_NOANSW;
    stCfg[j].ulAddrType =
        g_xCmMsg.uxData.xCallCfg.xSipFwd.xFwdAddrNoAns.ucAddrType;
    strcpy (stCfg[j].cDisplayName,
            g_xCmMsg.uxData.xCallCfg.xSipFwd.xFwdAddrNoAns.acDisplayName);
    strcpy (stCfg[j].cCFUserName,
            g_xCmMsg.uxData.xCallCfg.xSipFwd.xFwdAddrNoAns.acUserName);
    strcpy (stCfg[j].cCalledAddr,
            g_xCmMsg.uxData.xCallCfg.xSipFwd.xFwdAddrNoAns.acCalledAddr);
    stCfg[j].ulPort =
        g_xCmMsg.uxData.xCallCfg.xSipFwd.xFwdAddrNoAns.unPort;
    stCfg[j].ulAddrProto =
        g_xCmMsg.uxData.xCallCfg.xSipFwd.xFwdAddrNoAns.ucAddrProto;
}

/*
 * ===========================================================================
 *                          LOCAL FUNCTIONS
 * ===========================================================================
*/
/** returns the first data point within the ifxCallFwTable table data.

    Set the my_loop_context variable to the first data point structure
    of your choice (from which you can find the next one).  This could
    be anything from the first node in a linked list, to an integer
    pointer containing the beginning of an array variable.

    Set the my_data_context variable to something to be returned to
    you later that will provide you with the data to return in a given
    row.  This could be the same pointer as what my_loop_context is
    set to, or something different.

    The put_index_data variable contains a list of snmp variable
    bindings, one for each index in your table.  Set the values of
    each appropriately according to the data matching the first row
    and return the put_index_data variable at the end of the function.
*/
netsnmp_variable_list *
ifxCallFwTable_get_first_data_point(void **my_loop_context,
                                    void **my_data_context,
                                    netsnmp_variable_list * put_index_data,
                                    netsnmp_iterator_info *mydata)
{
    /* printf("**** ifxCallFwTable_get_first_data_point ****\n"); */
    int     *position;

    /* we could do this with a file-static variable, but for learning
       purposes we'll use memory allocation to demonstrate simplistic
       freeing of a loop_context */
    position = (int *)malloc(sizeof(int));
    if (!position)
        return NULL;

    ifxCallFwTable_get_data();

    /* We use the positinonal count as our loop context */
    *position = 0;
    *my_loop_context = position;

    /* our data context is the individual array element, in this case
       it's the first. */
    *my_data_context = &stCfg[*position];

    /* now, save the index data into the passed in (linked list) pointer */
    return ifxCallFwTable_set_indexes(&stCfg[*position], put_index_data);
}

/** functionally the same as ifxCallFwTable_get_first_data_point, but
   my_loop_context has already been set to a previous value and should
   be updated to the next in the list.  For example, if it was a
   linked list, you might want to cast it to your local data type and
   then return my_loop_context->next.  The my_data_context pointer
   should be set to something you need later and the indexes in
   put_index_data updated again. */
netsnmp_variable_list *
ifxCallFwTable_get_next_data_point(void **my_loop_context,
                                   void **my_data_context,
                                   netsnmp_variable_list * put_index_data,
                                   netsnmp_iterator_info *mydata)
{
    /* printf("**** ifxCallFwTable_get_next_data_point ****\n"); */
    int *position = (int *) *my_loop_context;

    /* make sure we were called correctly */
    if (!position)
        return NULL;
    
    /* go to the next entry in the list */
    (*position)++;

    /* Are we beyond the end? */
    if (*position >= MAX_CFTYPE)
    {
        /* End of entry.  stop here by returning NULL */
        free(position);
        *my_loop_context = NULL;
        *my_data_context = NULL;
        return NULL;
    }

    /* our data context is the individual array element, in this case
       it's the first. */
    *my_data_context = &stCfg[*position];

    /* now, save the index data into the passed in (linked list) pointer */
    return ifxCallFwTable_set_indexes(&stCfg[*position], put_index_data);
}

/** Create a data_context for non-existent rows that SETs are performed on.
 *  return a void * pointer which will be passed to subsequent get_XXX
 *  and set_XXX functions for data retrival and modification during
 *  this SET request.
 *
 *  The indexes are encoded (in order) into the index_data pointer,
 *  and the column object which triggered the row creation is available
 *  via the column parameter, if it would be helpful to use that information.
 */
void           *
ifxCallFwTable_create_data_context(netsnmp_variable_list * index_data,
                                   int column)
{
    return NULL;                /* XXX: you likely want to return a real pointer */
}

/** If the implemented set_* functions don't operate directly on the
   real-live data (which is actually recommended), then this function
   can be used to take a given my_data_context pointer and "commit" it
   to whereever the modified data needs to be put back to.  For
   example, if this was a routing table you could publish the modified
   routes back into the kernel at this point.

   new_or_del will be set to 1 if new, or -1 if it should be deleted
   or 0 if it is just a modification of an existing row.

   If you free the data yourself, make sure to *my_data_context = NULL */
int
ifxCallFwTable_commit_row(void **my_data_context, int new_or_del)
{
    VOIPCALLFWCFG_S         *datactx = *my_data_context;
    char                    sTemp[MAX_DATA_LEN];
    int                     nSetReturn = -1;
    u_long                  ulRetVal = 0;
    x_IFX_CM_SipCalledAddr  xCallAddr;

    /* printf("**** ifxCallFwTable_commit_row ****\n"); */

    if (new_or_del == -1)
    {
        return SNMP_ERR_NOERROR; /* no change in the value */
    }

    memset (&g_xCmMsg, 0x00, sizeof(x_IFX_CM_Msg));
    memset (&sTemp, 0x00, MAX_DATA_LEN);
    memset (&xCallAddr, 0x00, sizeof(x_IFX_CM_SipCalledAddr));

  	g_xCmMsg.ucMsgType = IFX_CM_GET_REQ;
	g_xCmMsg.ucInfoType = IFX_CM_APP_CALL_CFG;
	g_xCmMsg.ucChannel = 0;

    if (IFX_CM_RecvDataFromCM (&g_xCmMsg) != IFX_CM_SUCCESS)
    {
        snmp_log(LOG_ERR,"ifxCallFwTable: Fail to receive data from CM\n");
        return SNMP_ERR_COMMITFAILED;
    }

    xCallAddr.ucAddrType = datactx->ulAddrType;
    strcpy (xCallAddr.acDisplayName, datactx->cDisplayName);
    strcpy (xCallAddr.acUserName, datactx->cCFUserName);

    if (datactx->ulAddrType == IFX_CM_TEL_NUM)
    {
        memset (&datactx->cCalledAddr, 0x00, sizeof(IFX_CM_MAX_TSP_ADDR));
        strcpy (xCallAddr.acCalledAddr, datactx->cCalledAddr);
        xCallAddr.unPort = 5060;
        xCallAddr.ucAddrProto = IFX_CM_TRPROTO_NONE;
    }
    else
    {
        strcpy (xCallAddr.acCalledAddr, datactx->cCalledAddr);
        xCallAddr.unPort = datactx->ulPort;
        xCallAddr.ucAddrProto = datactx->ulAddrProto;
    }

    switch (datactx->ulType)
    {
        case IFX_CM_FWD_UNCOND:
            if (datactx->lRowStatus == IFX_CM_ON)
                g_xCmMsg.uxData.xCallCfg.xSipFwd.ucType |= IFX_CM_FWD_UNCOND;
            else
                g_xCmMsg.uxData.xCallCfg.xSipFwd.ucType &= ~IFX_CM_FWD_UNCOND;
            memcpy ((char *) &g_xCmMsg.uxData.xCallCfg.xSipFwd.xFwdAddrUncon,
                    (char *) &xCallAddr, sizeof(x_IFX_CM_SipCalledAddr));
            break;

        case IFX_CM_FWD_ONBUSY:
            if (datactx->lRowStatus == IFX_CM_ON)
                g_xCmMsg.uxData.xCallCfg.xSipFwd.ucType |= IFX_CM_FWD_ONBUSY;
            else
                g_xCmMsg.uxData.xCallCfg.xSipFwd.ucType &= ~IFX_CM_FWD_ONBUSY;
            memcpy ((char *) &g_xCmMsg.uxData.xCallCfg.xSipFwd.xFwdAddrBusy,
                    (char *) &xCallAddr, sizeof(x_IFX_CM_SipCalledAddr));
            break;

        case IFX_CM_FWD_NOANSW:
            if (datactx->lRowStatus == IFX_CM_ON)
                g_xCmMsg.uxData.xCallCfg.xSipFwd.ucType |= IFX_CM_FWD_NOANSW;
            else
                g_xCmMsg.uxData.xCallCfg.xSipFwd.ucType &= ~IFX_CM_FWD_NOANSW;
            memcpy ((char *) &g_xCmMsg.uxData.xCallCfg.xSipFwd.xFwdAddrNoAns,
                    (char *) &xCallAddr, sizeof(x_IFX_CM_SipCalledAddr));
            break;
    }

  	g_xCmMsg.ucMsgType = IFX_CM_SET_REQ;
	g_xCmMsg.ucInfoType = IFX_CM_APP_CALL_CFG;
	g_xCmMsg.ucChannel = 0;

    if (IFX_CM_SendDataToCM (&g_xCmMsg) != IFX_CM_SUCCESS)
    {
        snmp_log(LOG_ERR, "Fail to send Param data to CM");
        return SNMP_ERR_COMMITFAILED;
    }

    /*
     * return no errors.  And there shouldn't be any!!!  Ever!!!  You
     * should have checked the values long before this. 
     */
    return SNMP_ERR_NOERROR;
}


/*
 * User-defined data access functions (per column) for data in table ifxCallFwTable 
 */
/*
 * NOTE:
 * - these get_ routines MUST return data that will not be freed (ie,
 *   use static variables or persistent data).  It will be copied, if
 *   needed, immediately after the get_ routine has been called.
 * - these SET routines must copy the incoming data and can not take
 *   ownership of the memory passed in by the val pointer.
 */
/** XXX: return a data pointer to the data for the cfType column and set
         ret_len to its proper size in bytes. */
u_long         *
get_cfType(void *data_context, size_t * ret_len)
{
    VOIPCALLFWCFG_S   *datainfo = data_context;
	*ret_len = sizeof(datainfo->ulType);
    return &datainfo->ulType;
}

/** XXX: return a data pointer to the data for the cfAddressType column and set
         ret_len to its proper size in bytes. */
u_long         *
get_cfAddressType(void *data_context, size_t * ret_len)
{
    VOIPCALLFWCFG_S   *datainfo = data_context;
	*ret_len = sizeof(datainfo->ulAddrType);
    return &datainfo->ulAddrType;
}

/** XXX: Set the value of the cfAddressType column and return
         SNMP_ERR_NOERROR on success
         SNMP_ERR_XXX     for SNMP deterministic error codes
         SNMP_ERR_GENERR  on generic failures (a last result response). */
int
set_cfAddressType(void *data_context, u_long * val, size_t val_len)
{
    VOIPCALLFWCFG_S *datainfo = data_context;
    datainfo->ulAddrType = IFX_CM_IP_ADDR;
    memcpy(&datainfo->ulAddrType, val, val_len);
    return SNMP_ERR_NOERROR;
}

/** XXX: return a data pointer to the data for the cfDisplayName column and set
         ret_len to its proper size in bytes. */
char           *
get_cfDisplayName(void *data_context, size_t * ret_len)
{
    VOIPCALLFWCFG_S   *datainfo = data_context;
    *ret_len = strlen(datainfo->cDisplayName);
    return (char *) &datainfo->cDisplayName;
}

/** XXX: Set the value of the cfDisplayName column and return
         SNMP_ERR_NOERROR on success
         SNMP_ERR_XXX     for SNMP deterministic error codes
         SNMP_ERR_GENERR  on generic failures (a last result response). */
int
set_cfDisplayName(void *data_context, char *val, size_t val_len)
{
    VOIPCALLFWCFG_S *datainfo = data_context;
    memset(&datainfo->cDisplayName, 0x00, sizeof(datainfo->cDisplayName));
    memcpy(&datainfo->cDisplayName, val, val_len);
    return SNMP_ERR_NOERROR;
}

/** XXX: return a data pointer to the data for the cfUserName column and set
         ret_len to its proper size in bytes. */
char           *
get_cfUserName(void *data_context, size_t * ret_len)
{
    VOIPCALLFWCFG_S   *datainfo = data_context;
    *ret_len = strlen(datainfo->cCFUserName);
    return (char *) &datainfo->cCFUserName;
}

/** XXX: Set the value of the cfUserName column and return
         SNMP_ERR_NOERROR on success
         SNMP_ERR_XXX     for SNMP deterministic error codes
         SNMP_ERR_GENERR  on generic failures (a last result response). */
int
set_cfUserName(void *data_context, char *val, size_t val_len)
{
    VOIPCALLFWCFG_S *datainfo = data_context;
    memset(&datainfo->cCFUserName, 0x00, sizeof(datainfo->cCFUserName));
    memcpy(&datainfo->cCFUserName, val, val_len);
    return SNMP_ERR_NOERROR;
}

/** XXX: return a data pointer to the data for the cfAddress column and set
         ret_len to its proper size in bytes. */
char           *
get_cfAddress(void *data_context, size_t * ret_len)
{
    VOIPCALLFWCFG_S   *datainfo = data_context;
    *ret_len = strlen(datainfo->cCalledAddr);
    return (char *) &datainfo->cCalledAddr;
}

/** XXX: Set the value of the cfAddress column and return
         SNMP_ERR_NOERROR on success
         SNMP_ERR_XXX     for SNMP deterministic error codes
         SNMP_ERR_GENERR  on generic failures (a last result response). */
int
set_cfAddress(void *data_context, char *val, size_t val_len)
{
    VOIPCALLFWCFG_S *datainfo = data_context;
    memset(&datainfo->cCalledAddr, 0x00, sizeof(datainfo->cCalledAddr));
    memcpy(&datainfo->cCalledAddr, val, val_len);
    return SNMP_ERR_NOERROR;
}

/** XXX: return a data pointer to the data for the cfPort column and set
         ret_len to its proper size in bytes. */
u_long         *
get_cfPort(void *data_context, size_t * ret_len)
{
    VOIPCALLFWCFG_S   *datainfo = data_context;
	*ret_len = sizeof(datainfo->ulPort);
    return &datainfo->ulPort;
}

/** XXX: Set the value of the cfPort column and return
         SNMP_ERR_NOERROR on success
         SNMP_ERR_XXX     for SNMP deterministic error codes
         SNMP_ERR_GENERR  on generic failures (a last result response). */
int
set_cfPort(void *data_context, u_long * val, size_t val_len)
{
    VOIPCALLFWCFG_S *datainfo = data_context;
    datainfo->ulPort = 1024;
    memcpy(&datainfo->ulPort, val, val_len);
    return SNMP_ERR_NOERROR;
}

/** XXX: return a data pointer to the data for the cfProtocol column and set
         ret_len to its proper size in bytes. */
u_long         *
get_cfProtocol(void *data_context, size_t * ret_len)
{
    VOIPCALLFWCFG_S   *datainfo = data_context;
	*ret_len = sizeof(datainfo->ulAddrProto);
    return &datainfo->ulAddrProto;
}

/** XXX: Set the value of the cfProtocol column and return
         SNMP_ERR_NOERROR on success
         SNMP_ERR_XXX     for SNMP deterministic error codes
         SNMP_ERR_GENERR  on generic failures (a last result response). */
int
set_cfProtocol(void *data_context, u_long * val, size_t val_len)
{
    VOIPCALLFWCFG_S *datainfo = data_context;
    datainfo->ulAddrProto = IFX_CM_TRPROTO_NONE;
    memcpy(&datainfo->ulAddrProto, val, val_len);
    return SNMP_ERR_NOERROR;
}

/** XXX: return a data pointer to the data for the cfRowStatus column and set
         ret_len to its proper size in bytes. */
long           *
get_cfRowStatus(void *data_context, size_t * ret_len)
{
    VOIPCALLFWCFG_S   *datainfo = data_context;
	*ret_len = sizeof(datainfo->lRowStatus);
    return &datainfo->lRowStatus;
}

/** XXX: Set the value of the cfRowStatus column and return
         SNMP_ERR_NOERROR on success
         SNMP_ERR_XXX     for SNMP deterministic error codes
         SNMP_ERR_GENERR  on generic failures (a last result response). */
int
set_cfRowStatus(void *data_context, long *val, size_t val_len)
{
    VOIPCALLFWCFG_S *datainfo = data_context;
    datainfo->lRowStatus = ROWSTATUS_ACTIVE;
    memcpy(&datainfo->lRowStatus, val, val_len);
    return SNMP_ERR_NOERROR;
}
