/************************************************************************
 *
 *    Copyright (c) 2005
 *    Infineon Technologies AG
 *    St. Martin Strasse 53; 81669 Muenchen; Germany
 *
 *    This document contains proprietary information belonging to Infineon
 *    Technologies AG. Passing on and copying of this document, and communication
 *    of its contents is not permitted without prior written authorisation.
 *
 *    --------------------------------------------------------------------
 *    
 *        Project : INCA-IP
 *        Block   : IFX-IIP-VOIP-MIB
 *        Creator : Sharon Tseng
 *        File    : ifxCodecTable_checkfns_local.c
 *        Abstract: 
 *                  
 *        Date    : 24-May-2005
 *        Ref. Doc: IIP-DFS.doc
 *    
 *    Modification History:
 *           By              Date     Ver.   Modification Description
 *           --------------- -------- -----  -----------------------------
 *
 ************************************************************************/

/*
 * Note: this file originally auto-generated by mib2c using
 *        : mib2c.check_values_local.conf,v 5.2 2004/05/04 23:34:56 hardaker Exp $
 */

/*
 * ===========================================================================
 *                           INCLUDE FILES
 * ===========================================================================
 */
#include <net-snmp/net-snmp-config.h>
#include <net-snmp/net-snmp-includes.h>
#include "ifxCodecTable_checkfns.h"
#include "ifxCodecTable_columns.h"

/*
 * ===========================================================================
 *                          LOCAL FUNCTIONS
 * ===========================================================================
*/
/** Decides if an incoming value for the codecMediaBw mib node is legal, from a local implementation specific viewpoint.
 *  @param type    The incoming data type.
 *  @param val     The value to be checked.
 *  @param val_len The length of data stored in val (in bytes).
 *  @return 0 if the incoming value is legal, an SNMP error code otherwise.
 */
int
check_codecMediaBw_local(int type, u_long * val, size_t val_len,
                         u_long * old_val, size_t old_val_len)
{
    if (!(*val >= 80 && *val <= 1024))
        return SNMP_ERR_WRONGVALUE;

    return SNMP_ERR_NOERROR;
}

/** Decides if an incoming value for the codecName mib node is legal, from a local implementation specific viewpoint.
 *  @param type    The incoming data type.
 *  @param val     The value to be checked.
 *  @param val_len The length of data stored in val (in bytes).
 *  @return 0 if the incoming value is legal, an SNMP error code otherwise.
 */
int
check_codecName_local(int type, u_long * val, size_t val_len,
                      u_long * old_val, size_t old_val_len)
{
    if (!(*val == IFX_CM_RM_G711_ALAW ||
          *val == IFX_CM_RM_G711_ULAW ||
          *val == IFX_CM_RM_G729_8 ||
          *val == IFX_CM_RM_G729_E ||
          *val == IFX_CM_RM_G723_5_3 ||
          *val == IFX_CM_RM_G723_6_3 ||
          *val == IFX_CM_RM_G728 ||
          *val == IFX_CM_RM_G726_16 ||
          *val == IFX_CM_RM_G726_24 ||
          *val == IFX_CM_RM_G726_32 ||
          *val == IFX_CM_RM_G726_40 ||
          *val == IFX_CM_RM_G722_64 ||
          *val == IFX_CM_RM_T38) )
        return SNMP_ERR_WRONGVALUE;

    return SNMP_ERR_NOERROR;
}

/** Decides if an incoming value for the codecPayloadType mib node is legal, from a local implementation specific viewpoint.
 *  @param type    The incoming data type.
 *  @param val     The value to be checked.
 *  @param val_len The length of data stored in val (in bytes).
 *  @return 0 if the incoming value is legal, an SNMP error code otherwise.
 */
int
check_codecPayloadType_local(int type, u_long * val, size_t val_len,
                             u_long * old_val, size_t old_val_len)
{
    if (!(*val >= 96 && *val <= 127))
        return SNMP_ERR_WRONGVALUE;

    return SNMP_ERR_NOERROR;
}

/** Decides if an incoming value for the codecPriority mib node is legal, from a local implementation specific viewpoint.
 *  @param type    The incoming data type.
 *  @param val     The value to be checked.
 *  @param val_len The length of data stored in val (in bytes).
 *  @return 0 if the incoming value is legal, an SNMP error code otherwise.
 */
int
check_codecPriority_local(int type, u_long * val, size_t val_len,
                          u_long * old_val, size_t old_val_len)
{
    if (!(*val >= 0 && *val <= 12))
        return SNMP_ERR_WRONGVALUE;

    return SNMP_ERR_NOERROR;
}

/** Decides if an incoming value for the codecFrameSize mib node is legal, from a local implementation specific viewpoint.
 *  @param type    The incoming data type.
 *  @param val     The value to be checked.
 *  @param val_len The length of data stored in val (in bytes).
 *  @return 0 if the incoming value is legal, an SNMP error code otherwise.
 */
int
check_codecFrameSize_local(int type, u_long * val, size_t val_len,
                           u_long * old_val, size_t old_val_len)
{
    if (!(*val == CODECFRAMESIZE_5 ||
          *val == CODECFRAMESIZE_10 ||
          *val == CODECFRAMESIZE_20 ||
          *val == CODECFRAMESIZE_30) )
        return SNMP_ERR_WRONGVALUE;

    return SNMP_ERR_NOERROR;
}

/** Decides if an incoming value for the codecRowStatus mib node is legal, from a local implementation specific viewpoint.
 *  @param type    The incoming data type.
 *  @param val     The value to be checked.
 *  @param val_len The length of data stored in val (in bytes).
 *  @return 0 if the incoming value is legal, an SNMP error code otherwise.
 */
int
check_codecRowStatus_local(int type, long *val, size_t val_len,
                           long *old_val, size_t old_val_len)
{
    return SNMP_ERR_NOERROR;
}
