/************************************************************************
 *
 *    Copyright (c) 2005
 *    Infineon Technologies AG
 *    St. Martin Strasse 53; 81669 Muenchen; Germany
 *
 *    This document contains proprietary information belonging to Infineon
 *    Technologies AG. Passing on and copying of this document, and communication
 *    of its contents is not permitted without prior written authorisation.
 *
 *    --------------------------------------------------------------------
 *    
 *        Project : INCA-IP
 *        Block   : IFX-IIP-VOIP-MIB
 *        Creator : Sharon Tseng
 *        File    : ifxMediaSecProfTable_checkfns.c
 *        Abstract: 
 *                  
 *        Date    : 24-May-2005
 *        Ref. Doc: IIP-DFS.doc
 *    
 *    Modification History:
 *           By              Date     Ver.   Modification Description
 *           --------------- -------- -----  -----------------------------
 *
 ************************************************************************/

/*
 * Note: this file originally auto-generated by mib2c using
 *        : mib2c.check_values.conf,v 1.8 2004/01/12 00:43:45 rstory Exp $
 */

/********************************************************************
 *                       NOTE   NOTE   NOTE
 *   This file is auto-generated and SHOULD NOT BE EDITED by hand.
 *   Modify the ifxMediaSecProfTable_checkfns_local.[ch] files insead so that you
 *   can regenerate this one as mib2c improvements are made.
 ********************************************************************/

/*
 * ===========================================================================
 *                           INCLUDE FILES
 * ===========================================================================
 */
#include <net-snmp/net-snmp-config.h>
#include <net-snmp/net-snmp-includes.h>
#include "ifxMediaSecProfTable_checkfns.h"
#include "ifxMediaSecProfTable_columns.h"

/*
 * ===========================================================================
 *                          LOCAL FUNCTIONS
 * ===========================================================================
*/
/** Decides if an incoming value for the mspSRTPEncryAlgo mib node is legal.
 *  @param type    The incoming data type.
 *  @param val     The value to be checked.
 *  @param val_len The length of data stored in val (in bytes).
 *  @return 0 if the incoming value is legal, an SNMP error code otherwise.
 */
int
check_mspSRTPEncryAlgo(int type, u_long * val, size_t val_len,
                       u_long * old_val, size_t old_val_len)
{
    int             ret;

    /** Check to see that we were called legally */
    if (!val)
        return SNMP_ERR_GENERR;

    /** Check the incoming type for correctness */
    if (type != ASN_UNSIGNED)
        return SNMP_ERR_WRONGTYPE;

    if (!(*val == MSPENCRYALGO_NULL ||
          *val == MSPENCRYALGO_AES_CM) )
        return SNMP_ERR_WRONGVALUE;

    return SNMP_ERR_NOERROR;
}

/** Decides if an incoming value for the mspSRTPAuthAlgo mib node is legal.
 *  @param type    The incoming data type.
 *  @param val     The value to be checked.
 *  @param val_len The length of data stored in val (in bytes).
 *  @return 0 if the incoming value is legal, an SNMP error code otherwise.
 */
int
check_mspSRTPAuthAlgo(int type, u_long * val, size_t val_len,
                      u_long * old_val, size_t old_val_len)
{
    int             ret;

    /** Check to see that we were called legally */
    if (!val)
        return SNMP_ERR_GENERR;

    /** Check the incoming type for correctness */
    if (type != ASN_UNSIGNED)
        return SNMP_ERR_WRONGTYPE;

    if (!(*val == MSPAUTHALGO_NULL ||
          *val == MSPAUTHALGO_HMAC_SHA1) )
        return SNMP_ERR_WRONGVALUE;

    return SNMP_ERR_NOERROR;
}

/** Decides if an incoming value for the mspSRTPMasterKey mib node is legal.
 *  @param type    The incoming data type.
 *  @param val     The value to be checked.
 *  @param val_len The length of data stored in val (in bytes).
 *  @return 0 if the incoming value is legal, an SNMP error code otherwise.
 */
int
check_mspSRTPMasterKey(int type, char *val, size_t val_len,
                       char *old_val, size_t old_val_len)
{
    int             ret;

    /** Check to see that we were called legally */
    if (!val)
        return SNMP_ERR_GENERR;

    /** Check the incoming type for correctness */
    if (type != ASN_OCTET_STR)
        return SNMP_ERR_WRONGTYPE;

    /** Check the ranges of the passed value for legality */
    if (!(val_len >= 0 && val_len <= 32) )
    {
        return SNMP_ERR_WRONGVALUE;
    }

    return SNMP_ERR_NOERROR;
}

/** Decides if an incoming value for the mspSRTPMasterSalt mib node is legal.
 *  @param type    The incoming data type.
 *  @param val     The value to be checked.
 *  @param val_len The length of data stored in val (in bytes).
 *  @return 0 if the incoming value is legal, an SNMP error code otherwise.
 */
int
check_mspSRTPMasterSalt(int type, char *val, size_t val_len,
                        char *old_val, size_t old_val_len)
{
    int             ret;

    /** Check to see that we were called legally */
    if (!val)
        return SNMP_ERR_GENERR;

    /** Check the incoming type for correctness */
    if (type != ASN_OCTET_STR)
        return SNMP_ERR_WRONGTYPE;

    /** Check the ranges of the passed value for legality */
    if (!(val_len >= 0 && val_len <= 32)
        ) {
        return SNMP_ERR_WRONGVALUE;
    }

    return SNMP_ERR_NOERROR;
}

/** Decides if an incoming value for the mspSRTPMKIFlag mib node is legal.
 *  @param type    The incoming data type.
 *  @param val     The value to be checked.
 *  @param val_len The length of data stored in val (in bytes).
 *  @return 0 if the incoming value is legal, an SNMP error code otherwise.
 */
int
check_mspSRTPMKIFlag(int type, u_long * val, size_t val_len,
                     u_long * old_val, size_t old_val_len)
{
    int             ret;

    /** Check to see that we were called legally */
    if (!val)
        return SNMP_ERR_GENERR;

    /** Check the incoming type for correctness */
    if (type != ASN_UNSIGNED)
        return SNMP_ERR_WRONGTYPE;

    if (!(*val == IFX_CM_OFF ||
          *val == IFX_CM_ON) )
        return SNMP_ERR_WRONGVALUE;

    return SNMP_ERR_NOERROR;
}

/** Decides if an incoming value for the mspSRTPMKI mib node is legal.
 *  @param type    The incoming data type.
 *  @param val     The value to be checked.
 *  @param val_len The length of data stored in val (in bytes).
 *  @return 0 if the incoming value is legal, an SNMP error code otherwise.
 */
int
check_mspSRTPMKI(int type, u_long * val, size_t val_len,
                 u_long * old_val, size_t old_val_len)
{
    int             ret;

    /** Check to see that we were called legally */
    if (!val)
        return SNMP_ERR_GENERR;

    /** Check the incoming type for correctness */
    if (type != ASN_UNSIGNED)
        return SNMP_ERR_WRONGTYPE;

    return SNMP_ERR_NOERROR;
}

/** Decides if an incoming value for the mspSRTCPEncryAlgo mib node is legal.
 *  @param type    The incoming data type.
 *  @param val     The value to be checked.
 *  @param val_len The length of data stored in val (in bytes).
 *  @return 0 if the incoming value is legal, an SNMP error code otherwise.
 */
int
check_mspSRTCPEncryAlgo(int type, u_long * val, size_t val_len,
                        u_long * old_val, size_t old_val_len)
{
    int             ret;

    /** Check to see that we were called legally */
    if (!val)
        return SNMP_ERR_GENERR;

    /** Check the incoming type for correctness */
    if (type != ASN_UNSIGNED)
        return SNMP_ERR_WRONGTYPE;

    if (!(*val == MSPENCRYALGO_NULL ||
          *val == MSPENCRYALGO_AES_CM) )
        return SNMP_ERR_WRONGVALUE;

    return SNMP_ERR_NOERROR;
}

/** Decides if an incoming value for the mspSRTCPAuthAlgo mib node is legal.
 *  @param type    The incoming data type.
 *  @param val     The value to be checked.
 *  @param val_len The length of data stored in val (in bytes).
 *  @return 0 if the incoming value is legal, an SNMP error code otherwise.
 */
int
check_mspSRTCPAuthAlgo(int type, u_long * val, size_t val_len,
                       u_long * old_val, size_t old_val_len)
{
    int             ret;

    /** Check to see that we were called legally */
    if (!val)
        return SNMP_ERR_GENERR;

    /** Check the incoming type for correctness */
    if (type != ASN_UNSIGNED)
        return SNMP_ERR_WRONGTYPE;

    if (!(*val == MSPAUTHALGO_NULL||
          *val == MSPAUTHALGO_HMAC_SHA1) )
        return SNMP_ERR_WRONGVALUE;

    return SNMP_ERR_NOERROR;
}

/** Decides if an incoming value for the mspSRTCPMasterKey mib node is legal.
 *  @param type    The incoming data type.
 *  @param val     The value to be checked.
 *  @param val_len The length of data stored in val (in bytes).
 *  @return 0 if the incoming value is legal, an SNMP error code otherwise.
 */
int
check_mspSRTCPMasterKey(int type, char *val, size_t val_len,
                        char *old_val, size_t old_val_len)
{
    int             ret;

    /** Check to see that we were called legally */
    if (!val)
        return SNMP_ERR_GENERR;

    /** Check the incoming type for correctness */
    if (type != ASN_OCTET_STR)
        return SNMP_ERR_WRONGTYPE;

    /** Check the ranges of the passed value for legality */
    if (!(val_len >= 0 && val_len <= 32)
        ) {
        return SNMP_ERR_WRONGVALUE;
    }

    return SNMP_ERR_NOERROR;
}

/** Decides if an incoming value for the mspSRTCPMasterSalt mib node is legal.
 *  @param type    The incoming data type.
 *  @param val     The value to be checked.
 *  @param val_len The length of data stored in val (in bytes).
 *  @return 0 if the incoming value is legal, an SNMP error code otherwise.
 */
int
check_mspSRTCPMasterSalt(int type, char *val, size_t val_len,
                         char *old_val, size_t old_val_len)
{
    int             ret;

    /** Check to see that we were called legally */
    if (!val)
        return SNMP_ERR_GENERR;

    /** Check the incoming type for correctness */
    if (type != ASN_OCTET_STR)
        return SNMP_ERR_WRONGTYPE;

    /** Check the ranges of the passed value for legality */
    if (!(val_len >= 0 && val_len <= 32)
        ) {
        return SNMP_ERR_WRONGVALUE;
    }

    return SNMP_ERR_NOERROR;
}

/** Decides if an incoming value for the mspSRTCPMKIFlag mib node is legal.
 *  @param type    The incoming data type.
 *  @param val     The value to be checked.
 *  @param val_len The length of data stored in val (in bytes).
 *  @return 0 if the incoming value is legal, an SNMP error code otherwise.
 */
int
check_mspSRTCPMKIFlag(int type, u_long * val, size_t val_len,
                      u_long * old_val, size_t old_val_len)
{
    int             ret;

    /** Check to see that we were called legally */
    if (!val)
        return SNMP_ERR_GENERR;

    /** Check the incoming type for correctness */
    if (type != ASN_UNSIGNED)
        return SNMP_ERR_WRONGTYPE;

    if (!(*val == IFX_CM_OFF ||
          *val == IFX_CM_ON) )
        return SNMP_ERR_WRONGVALUE;

    return SNMP_ERR_NOERROR;
}

/** Decides if an incoming value for the mspSRTCPMKI mib node is legal.
 *  @param type    The incoming data type.
 *  @param val     The value to be checked.
 *  @param val_len The length of data stored in val (in bytes).
 *  @return 0 if the incoming value is legal, an SNMP error code otherwise.
 */
int
check_mspSRTCPMKI(int type, u_long * val, size_t val_len,
                  u_long * old_val, size_t old_val_len)
{
    int             ret;

    /** Check to see that we were called legally */
    if (!val)
        return SNMP_ERR_GENERR;

    /** Check the incoming type for correctness */
    if (type != ASN_UNSIGNED)
        return SNMP_ERR_WRONGTYPE;

    return SNMP_ERR_NOERROR;
}

/** Decides if an incoming value for the mspRowStatus mib node is legal.
 *  @param type    The incoming data type.
 *  @param val     The value to be checked.
 *  @param val_len The length of data stored in val (in bytes).
 *  @return 0 if the incoming value is legal, an SNMP error code otherwise.
 */
int
check_mspRowStatus(int type, long *val, size_t val_len,
                   long *old_val, size_t old_val_len)
{
    int             ret;

    /** Check to see that we were called legally */
    if (!val)
        return SNMP_ERR_GENERR;

    /** Check the incoming type for correctness */
    if (type != ASN_INTEGER)
        return SNMP_ERR_WRONGTYPE;

    /** Check the enums.  Legal values will continue, others return error. */
    switch (*val) {
    case ROWSTATUS_ACTIVE:
    case ROWSTATUS_NOTINSERVICE:
    case ROWSTATUS_NOTREADY:
    case ROWSTATUS_CREATEANDGO:
    case ROWSTATUS_CREATEANDWAIT:
    case ROWSTATUS_DESTROY:
        break;

    /** not a legal enum value.  return an error */
    default:
        return SNMP_ERR_INCONSISTENTVALUE;
    }
    ret = SNMP_ERR_NOERROR;

    if (ret =
        check_rowstatus_transition((old_val) ? *old_val : RS_NONEXISTENT,
                                   *val))
        return ret;

    return SNMP_ERR_NOERROR;
}
