/************************************************************************
 *
 *    Copyright (c) 2005
 *    Infineon Technologies AG
 *    St. Martin Strasse 53; 81669 Muenchen; Germany
 *
 *    This document contains proprietary information belonging to Infineon
 *    Technologies AG. Passing on and copying of this document, and communication
 *    of its contents is not permitted without prior written authorisation.
 *
 *    --------------------------------------------------------------------
 *    
 *        Project : INCA-IP
 *        Block   : IFX-IIP-VOIP-MIB
 *        Creator : Sharon Tseng
 *        File    : ifxMediaSecProfTable_columns.h
 *        Abstract: 
 *                  
 *        Date    : 24-May-2005
 *        Ref. Doc: IIP-DFS.doc
 *    
 *    Modification History:
 *           By              Date     Ver.   Modification Description
 *           --------------- -------- -----  -----------------------------
 *
 ************************************************************************/

/*
 * Note: this file originally auto-generated by mib2c using
 *  : mib2c.column_defines.conf,v 5.1 2002/05/08 05:42:47 hardaker Exp $
 */
#ifndef IFXMEDIASECPROFTABLE_COLUMNS_H
#define IFXMEDIASECPROFTABLE_COLUMNS_H

/*
 * ===========================================================================
 *                           INCLUDE FILES
 * ===========================================================================
*/
#include <ifxCommon/ifxMIB_common.h>

/*
 * ===========================================================================
 *                           ENUM TYPES
 * ===========================================================================
*/
/*
 * enums for column mspSRTPEncryAlgo or mspSRTCPEncryAlgo
 */
#define MSPENCRYALGO_NULL       0
#define MSPENCRYALGO_AES_CM     1

/*
 * enums for column mspSRTPAuthAlgo or mspSRTCPAuthAlgo
 */
#define MSPAUTHALGO_NULL        0
#define MSPAUTHALGO_HMAC_SHA1   1

/*
 * ===========================================================================
 *                          DEFINITIONS
 * ===========================================================================
*/
/*
 * column number definitions for table ifxMediaSecProfTable 
 */
#define COLUMN_MSPINDEX             1
#define COLUMN_MSPSRTPENCRYALGO     2
#define COLUMN_MSPSRTPAUTHALGO      3
#define COLUMN_MSPSRTPMASTERKEY     4
#define COLUMN_MSPSRTPMASTERSALT    5
#define COLUMN_MSPSRTPMKIFLAG       6
#define COLUMN_MSPSRTPMKI           7
#define COLUMN_MSPSRTCPENCRYALGO    8
#define COLUMN_MSPSRTCPAUTHALGO     9
#define COLUMN_MSPSRTCPMASTERKEY    10
#define COLUMN_MSPSRTCPMASTERSALT   11
#define COLUMN_MSPSRTCPMKIFLAG      12
#define COLUMN_MSPSRTCPMKI          13
#define COLUMN_MSPROWSTATUS         14


/*
 * ===========================================================================
 *                        USER-DEFINED DATA TYPES
 * ===========================================================================
*/
/* VoIP Media Security Profile Configuration*/
typedef struct
{
    u_long ulEndPointIdx;
    char cUserName[IFX_CM_MAX_USR_NAME];
    char cDomainName[IFX_CM_MAX_DOMAIN_NAME];
    u_long ulIndex;
    u_long ulSRTPEncry;
    u_long ulSRTPAuth;
    char cSRTPMasterKy[33];
    char cSRTPMasterSalt[33];
    u_long ulSRTPFlag;
    u_long ulSRTPMKI;
    u_long ulSRTCPEncry;
    u_long ulSRTCPAuth;
    char cSRTCPMasterKy[33];
    char cSRTCPMasterSalt[33];
    u_long ulSRTCPFlag;
    u_long ulSRTCPMKI;
    long lRowStatus;

} VOIPMEDIASECPROFCFG_S;
#endif                          /* IFXMEDIASECPROFTABLE_COLUMNS_H */
